program  BILLARD;

{M=0,N=2 -> ELLIPSE / M=2,N=4 -> HYPERBOLE / M=0.5,N=2 -> FOYER}

uses Crt, Printer, Graph, Graph2D;

const  A         = 5;
       B         = 3;
       Limite    = 60;
       Increment = 0.1;

var  F1, F2, F3, F4 : real;
     M, N           : real;
     NbreRebonds    : real;
     X1, Y1, X2, Y2 : real;
     Intersection   : boolean;

procedure EntreeDonnees;
begin
   clrscr;
   highvideo;
   writeln ('SIMULATION D''UN BILLARD ELLIPTIQUE');
   writeln ('==================================');
   lowvideo;
   gotoxy(1, 10);
   write ('La bille est lance selon une droite  Y = M.X + N');
   gotoxy(1, 15);
   write ('Entrez M et N : ');
   readln (M,N);
   F1 := -1.1 * A; F2 := 1.1 * A; F3 := -1.1 * B; F4 := 1.1 * B
end;

procedure TestDroiteCoupeEllipse;
var  Delta : real;
begin
   Delta := A * A * B * B * (A * A * M * M + B * B - N * N) ;
   Intersection := (Delta > 0)
end;

procedure DessineEllipse;
var  Angle, X1, Y1, X2, Y2 : real;
begin
   Angle := 0;
   X1    := A;
   Y1    := 0;
   DeplaceEn (X1, Y1);
   while Angle < 2 * Pi do
      begin
         Angle := Angle + Increment;
         X2    := A * cos(Angle);
         Y2    := B * sin(Angle);
         TraceVers (X2, Y2)
      end
end;

procedure TraceLesFoyers;
var  XF, L : real;

   procedure CroixAuFoyer (X, Y: real);
   begin
      DeplaceEn (X - L, Y);
      TraceVers (X + L, Y);
      DeplaceEn (X, Y - L);
      TraceVers (X, Y + L)
   end;

begin
    XF := sqrt(A * A - B * B);
    L  := 0.03 * A;
    CroixAuFoyer (-XF, 0);
    CroixAuFoyer (XF, 0)
end;

procedure Permute;
var Aux : real;
begin
   Aux := X1; X1 := X2; X2 := Aux;
   Aux := Y1; Y1 := Y2; Y2 := Aux
end;

procedure CherchePointsIntersection;
var  Delta, Denom : real;
begin
   Delta := A * A * B * B * (A * A * M * M + B * B - N * N);
   Denom := A * A * M * M + B * B;
   X1    := (-A * A * M * N + sqrt(Delta)) / Denom;
   Y1    := M * X1 + N;
   X2    := (-A * A * M * N - sqrt(Delta)) / Denom;
   Y2    := M * X2 + N;
   If M>0
      then begin
              if Y1>Y2 then permute
           end
      else if M<0 then begin
                          if Y1<Y2 then permute
                       end
                  else if X1>X2 then permute
end;

procedure TrajectoireBille;
var XPrecedent, YPrecedent : real;
    TgPhi, TgTheta         : real;
    AngleInc, AnglePhi     : real;
begin
   NbreRebonds := 0;
   DeplaceEn (F1, M * F1 + N);
   TraceVers (X2, Y2);
   NbreRebonds := NbreRebonds + 1;
   repeat
      if X2 <> 0 then TgPhi := A * A * Y2 / (B * B * X2)
                 else TgPhi := 1E20;
      TgTheta  := M;
      AngleInc := arctan((TgPhi-TgTheta)/(1+TgPhi*TgTheta));
      AnglePhi := arctan(TgPhi);
      M        := sin(AngleInc+AnglePhi)/cos(AngleInc+AnglePhi);
      if abs(N) < 1E-3 then begin
                               M := 0;
                               N := 0
                            end
                        else N := Y2 - M * X2;
      XPrecedent := X2;
      YPrecedent := Y2;
      CherchePointsIntersection;
      If abs(XPrecedent - X1) > 1E-6 then Permute;
      DeplaceEn (XPrecedent, YPrecedent);
      TraceVers (X2, Y2);
      NbreRebonds := NbreRebonds + 1
   until NbreRebonds > Limite
end;

BEGIN
   EntreeDonnees;
   TestDroiteCoupeEllipse;
   if Intersection
      then
         begin
            EcranGraphique;
            Fenetre (F1, F2, F3, F4);
            Cloture (0, MaxX, 9, MaxY);
            TraceBordure;
            DessineEllipse;
            TraceLesFoyers;
            CherchePointsIntersection;
            TrajectoireBille;
            Attente;
            Ecrantexte
         end
      else Writeln (#7'La droite ne coupe pas l''ellipse.')
END.
