{Le clbre problme du parcours du cavalier sur l'chiquier}

program CAVALGR;

Uses Crt, Graph, Graph2D;

var Echiquier             : array [-1..10,-1..10] of byte;
    XCaseFuite            : array [1..8] of byte;
    YCaseFuite            : array [1..8] of byte;
    NbreCasesFuites       : array [1..8] of byte;
    Caval                 : pointer;
    Compteur, Cpt2        : byte;
    Ordre, Ligne, Colonne : byte;
    CaseDeFuiteExiste     : boolean;
    Lig, Col, CT          : integer;

const PasY  = 38;
      Duree = 1000;

procedure LectureOrdre;
begin
   clrscr;
   repeat
      write ('Entrez l''ordre de l''chiquier (3 < Ordre < 9): ');
      readln (Ordre)
   until (Ordre > 3) and (Ordre < 9)
end;

procedure LectureCaseDepart;
begin
   writeln;
   writeln ('Entrez la coordonne de la case de dpart');
   repeat
      write ('Numro de colonne: ');
      readln (Colonne)
   until (Colonne > 0) and (Colonne <= Ordre);
   repeat
      write ('Numro de ligne  : ');
      readln (Ligne)
   until (Ligne > 0) and (Ligne <= Ordre)
end;

procedure AffichageSolution;
var Ch, S1, S2 : string;
begin
   str(Ligne, S1);
   str(Colonne, S2);
   Ch := concat('(',S2,',',S1,')');
   CT := CT + 1;
   Col := CT mod 4;
   case (CT mod 4) of
      0 : OutTextXY (Col * 77 + 420, Lig, Ch);
      1 : OutTextXY (Col * 77 + 420, Lig, Ch);
      2 : OutTextXY (Col * 77 + 420, Lig, Ch);
      3 : begin
             OutTextXY (Col * 77 + 420, Lig, Ch);
             Lig := Lig + 15
          end
   end
end;

procedure PoseCavalier;
var Ch   : string;
    X, Y : integer;
begin
   X := (Colonne - 1) * 50;
   Y := 310 - Ligne * 38;
   PutImage (X, Y, Caval^, XORput);
   delay (Duree);
   PutImage (X, Y, Caval^, XORput);
   Compteur := Compteur + 1;
   str (Compteur, Ch);
   OutTextXY (X + 20, Y + 15, Ch);
   Echiquier [Ordre - Ligne + 1, Colonne] := Compteur;
   AffichageSolution
end;

procedure Initialisation;
var L, C : integer;
begin
   EcranGraphique;

   fillchar (Echiquier, sizeof(Echiquier), 1);
   for L := 1 to Ordre do
      for C := 1 to Ordre do Echiquier [L, C] := 0;
   Compteur := 0;
   CaseDeFuiteExiste := true;
   CT  := -1;
   Lig := 10 + (8 - Ordre) * 38;
   Col := 0
end;

procedure CreeImageCavalier;
begin
   moverel (15,33);linerel (25,0);linerel (5,-13);linerel (-5,-10);
   linerel (-10,-2);linerel (0,-3);linerel (-5,3);linerel (-2,-3);
   linerel (-3,3);linerel (-5,3);linerel (-10,7);linerel (0,3);
   linerel (7,-2);linerel (-5,4);linerel (8,-2);linerel (10,0);
   linerel (-10,9);linerel (0,3);circle (23, 12, 3);
   FloodFill (35, 20, Blanc)
end;

procedure LireImageCavalier;
var  Xg, Xd, Yb, Yh, Size : word;
begin
   Xg := 0;
   Xd := 50;
   Yb := 0;
   Yh := 37;
   Size := ImageSize (Xg, Yb, Xd, Yh);
   GetMem (Caval, Size);
   GetImage (Xg, Yb, Xd, Yh, Caval^);
   PutImage (Xg, Yb, Caval^, XORput);
end;

procedure TraceEchiquier;
var I : byte;
begin
   for I := 0 to Ordre do
   begin
      MoveTo (0, 310 - I * 38);
      LineTo (Ordre * 50, 310 - I * 38)
   end;
   for I := 0 to Ordre do
   begin
      MoveTo (I * 50, 310);
      LineTo (I * 50, 310 - Ordre * 38)
   end
end;

procedure ChercheCasesLibresAutourDuCavalier;
var Cpt, I, LL, CC, Ind : byte;

    procedure TourneAutourCase (Lg, Cl, Ind: byte);
    var L, C : integer;

        procedure TestCaseLibre;
        begin
           if Echiquier [Ordre - L + 1, C] = 0 then
           begin
              inc (Cpt);
              if Ind = 1 then
              begin
                 XCaseFuite [Cpt] := C;
                 YCaseFuite [Cpt] := L
              end
           end
        end;

    begin
       Cpt := 0;
       CaseDeFuiteExiste := true;
       L := Lg + 2;     C := Cl - 1;     TestCaseLibre;
       L := Lg + 2;     C := Cl + 1;     TestCaseLibre;
       L := Lg + 1;     C := Cl + 2;     TestCaseLibre;
       L := Lg - 1;     C := Cl + 2;     TestCaseLibre;
       L := Lg - 2;     C := Cl + 1;     TestCaseLibre;
       L := Lg - 2;     C := Cl - 1;     TestCaseLibre;
       L := Lg - 1;     C := Cl - 2;     TestCaseLibre;
       L := Lg + 1;     C := Cl - 2;     TestCaseLibre
    end;

begin
   fillchar (XCaseFuite, sizeof(XCaseFuite), 0);
   fillchar (YCaseFuite, sizeof(YCaseFuite), 0);
   TourneAutourCase (Ligne, Colonne, 1);
   if Cpt <> 0
      then
         begin
            Cpt2 := Cpt;
            for I:= 1 to Cpt2 do
            begin
               CC := XCaseFuite [I];
               LL := YCaseFuite [I];
               TourneAutourCase (LL, CC, 2);
               NbreCasesFuites [I] := Cpt;
            end
         end
      else CaseDeFuiteExiste := false
end;

procedure ChoixCaseSuivante;
var Min, Pos, I : byte;
begin
   Min := 255;
   Pos := 0;
   for I := 1 to Cpt2 do
      if NbreCasesFuites [I] < Min
         then begin
                 Min := NbreCasesFuites [I];
                 Pos := I
              end;
   Ligne   := YCaseFuite [Pos];
   Colonne := XCaseFuite [Pos]
end;


procedure ChercheUneSolution;
begin
   while (Compteur < sqr(Ordre)) and CaseDeFuiteExiste do
   begin
      PoseCavalier;
      ChercheCasesLibresAutourDuCavalier;
      if CaseDeFuiteExiste then ChoixCaseSuivante
   end
end;

BEGIN
   LectureOrdre;
   LectureCaseDepart;
   Initialisation;
   CreeImageCavalier;
   LireImageCavalier;
   TraceEchiquier;
   ChercheUneSolution;
   Attente;
   EcranTexte
END.
