program CUBE3D;          { Cube tournant dans l'espace }

Uses Crt, Graph, GRAPH3D;

const IncAng   = 5;
      IncRho   = 0.5;
      IncEcran = 20;

var X, Y, Z, C : array[1..21] of real;
    Ch         : char;

procedure LectureCube;
begin X[1] := 1;    Y[1] := 1;    Z[1] := 1;     C[1] := 0;
      X[2] := 1;    Y[2] := -1;   Z[2] := 1;     C[2] := 1;
      X[3] := -1;   Y[3] := -1;   Z[3] := 1;     C[3] := 1;
      X[4] := -1;   Y[4] := 1;    Z[4] := 1;     C[4] := 1;
      X[5] := 1;    Y[5] := 1;    Z[5] := 1;     C[5] := 1;
      X[6] := 1;    Y[6] := 1;    Z[6] := -1;    C[6] := 1;
      X[7] := 1;    Y[7] := -1;   Z[7] := -1;    C[7] := 1;
      X[8] := -1;   Y[8] := -1;   Z[8] := -1;    C[8] := 1;
      X[9] := -1;   Y[9] := 1;    Z[9] := -1;    C[9] := 1;
     X[10] := 1;    Y[10] := 1;   Z[10] := -1;   C[10] := 1;
     X[11] := 1;    Y[11] := -1;  Z[11] := -1;   C[11] := 0;
     X[12] := 1;    Y[12] := -1;  Z[12] := 1;    C[12] := 1;
     X[13] := -1;   Y[13] := -1;  Z[13] := 1;    C[13] := 0;
     X[14] := -1;   Y[14] := -1;  Z[14] := -1;   C[14] := 1;
     X[15] := -1;   Y[15] := 1;   Z[15] := 1;    C[15] := 0;
     X[16] := -1;   Y[16] := 1;   Z[16] := -1;   C[16] := 1;
     X[17] := 0.5;  Y[17] := 1;   Z[17] := -1;   C[17] := 0;
     X[18] := 0.5;  Y[18] := 1;   Z[18] := 0.5;  C[18] := 1;
     X[19] := -0.5; Y[19] := 1;   Z[19] := 0.5;  C[19] := 1;
     X[20] := -0.5; Y[20] := 1;   Z[20] := -1;   C[20] := 1;
     X[21] := 0;    Y[21] := 0;   Z[21] := 0;    C[21] := -1
end;

procedure DessineCube;
var I : byte;
begin
   I := 1;
   while C[I] <> -1 do
   begin
      If C[I]=0
         then DeplaceEn(X[I], Y[I], Z[I])
         else TraceVers(X[I], Y[I], Z[I]);
      I := I + 1
   end
end;

procedure Initialisation;
begin
   Projection := Perspective;
   Rho   := 5;
   Theta := 0;
   Phi   := 0;
   DE    := 200
end;

procedure Dessine;
begin
   InitialiseProjection;
   DessineCube;
   Bip
end;

procedure Affichage;
var S1, S2, S3, S4, S5 : string;
begin
   Cloture (0, MaxX, 0, 15);
   ClearViewPort;
   SetTextStyle (SmallFont, HorizDir, 5);
   str (Theta:3:1, S2);
   str (Phi:3:1, S3);
   str (DE:4:1, S4);
   if projection = Perspective
   then
      begin
         str (Rho:3:1, S1);
         OutTextXY (90, 1,'Projection Perspective: Rho='+S1+
                  '   Theta= '+S2+'   Phi='+S3+'  Ecran='+S4)
      end
   else
         OutTextXY (90, 1,'Projection Parallele: Rho=infini'+
                  '   Theta= '+S2+'   Phi='+S3+'  Ecran='+S4);
   Cloture (0, MaxX, 0, MaxY)
end;

procedure Commandes;
const RhoPara = 1E20;
var RhoPersp, DEPersp, DEPara: real;
    Ch : char;
begin
   Initialisation;
   DEPara := 50;
   repeat
      Dessine;
      Affichage;
      Ch := readkey;
      if Ch = #0 then Ch := readkey;
      ClearDevice;
      case ord(UpCase(Ch)) of
         72 : Phi   := Phi + IncAng;
         80 : Phi   := Phi - IncAng;
         75 : Theta := Theta - IncAng;
         77 : Theta := Theta + IncAng;
         69 : Rho   := Rho + IncRho;
         65 : Rho   := Rho - IncRho;
         43 : DE    := DE + IncEcran;
         45 : DE    := DE - IncEcran;
         67 : If Projection = Perspective
                 then begin
                         RhoPersp := Rho;
                         DEPersp  := DE;
                         Projection := Parallele;
                         Rho := RhoPara;
                         DE  := DEPara
                      end
                 else begin
                         DEPara := DE;
                         Projection := Perspective;
                         Rho := RhoPersp;
                         DE  := DEPersp
                      end
      end;
   until UpCase(Ch) = 'F';
   EcranTexte
end;

BEGIN
   EcranGraphique;
   Cloture (0, MaxX, 0, MaxY);
   Couleur (Blanc);
   LectureCube;
   Initialisation;
   Commandes;
END.

