program CYCLO;         { Trac de courbes cyclodales }

uses Crt, Graph, Graph2D;

var Aux1, Aux2, Aux3 : real;
    R1, R2, L        : real;
    RayonMax         : real;
    Periode          : real;
    Generateurs      : char;

function FX(T: real) : real;
begin
   FX := Aux1 * cos(T)-Aux3 * cos(Aux2 * T)
end;

function FY(T: real) : real;
begin
   FY := Aux1 * sin(T)-Aux3 * sin(Aux2 * T)
end;

procedure RechercheAutomatiquePeriode;
var  XDepart, YDepart   : real;
     XCourant, YCourant : real;
     DeltaX, DeltaY     : real;
begin
   Periode := 0;
   XDepart := FX(0);
   YDepart := FY(0);
   repeat
      Periode  := Periode + 2 * Pi;
      XCourant := FX(Periode);
      YCourant := FY(Periode);
      DeltaX   := abs(XCourant-XDepart);
      DeltaY   := abs(YCourant-YDepart)
   until ((DeltaX < 1E-6) and (DeltaY < 1E-6)) or (Periode > 200*Pi)
end;

procedure EntreeDesDonnees;
begin
   clrscr;
   writeln ('LES COURBES CYCLOIDES');
   writeln ('=====================');
   writeln;
   writeln ('R1=rayon du cercle fixe');
   writeln ('R2=rayon du cercle mobile');
   writeln;
   writeln ('Si R2>0 on a une picyclode');
   writeln ('Si R2<0 on a une hypocyclode');
   writeln;
   writeln ('Si L>1 on obtient une courbe allonge');
   writeln ('Si L=1 on obtient une courbe normale');
   writeln ('Si 0<L<1 on obtient une courbe raccourcie');
   writeln;
   write ('Entrez  R1 : ');
   readln (R1);
   write ('Entrez  R2 : ');
   readln (R2);
   writeln;
   repeat
      write ('Entrez  L  : ');
      readln (L)
   until L >= 0;
   Aux1 := R1 + R2;
   Aux2 := (R1 + R2) / R2;
   Aux3 := L * R2;
   writeln;
   write ('Faut-il tracer les cercles gnrateurs (O/N) ');
   readln (Generateurs)
end;

procedure RechercheFenetre;
begin
   RayonMax := 0;
   if L >= 1
      then RayonMax := R1 + R2 + abs(L * R2)
      else if R2 > 0
              then RayonMax := R1 + 2 * R2
              else RayonMax := R1
end;

procedure DessineCourbe;
var A, Pas : real;
begin
   A   := 0;
   Pas := Pi / 48;
   DeplaceEn (FX(0), FY(0));
   repeat
      A := A + Pas;
      TraceVers (FX(A), FY(A))
   until A >= Periode
end;

procedure CerclesGenerateurs;
begin
   CerclePointille (0, 0, R1);
   CerclePointille (R1 + R2, 0, R2)
end;

procedure AffichageParametres;
var S1, S2, S3, S4, S5 : string;
begin
   str (R1:5:2, S1);
   str (R2:5:2, S2);
   str (L:5:2, S3);
   str (Periode:8:5, S4);
   str (RayonMax:8:5, S5);
   Cloture (0, MaxX, 0, 11);
   OutTextXY (10,0,'R1='+S1 + '       R2=' + S2 + '       L=' + S3 +
                   '        Periode=' + S4 + '         RayonMax='+S5)
end;

BEGIN
   EntreeDesDonnees;
   RechercheAutomatiquePeriode;
   RechercheFenetre;
   EcranGraphique;
   Fenetre(-RayonMax, RayonMax, -RayonMax, RayonMax);
   Cloture (0,MaxX,0,MaxY);
   TraceBordure;
   Cloture(140, 580, 15, 345);
   if upcase(Generateurs) = 'O' then CerclesGenerateurs;
   DessineCourbe;
   AffichageParametres;
   Attente;
   EcranTexte
END.
