program Fractal2;

uses Crt, Graph, Graph2D;

const Limite = 4096;

var  XBase, YBase   : array [0..10] of real;
     Xgen, YGen     : array [0..20] of real;
     XFract, YFract : array [0..Limite] of real;
     Ordre          : byte;
     PointsBase     : byte;
     PointsGen      : byte;
     F1, F2, F3, F4 : real;
     NomCourbe      : string;

function PuisEntier (Base, Exposant: integer) : word;
var I, Prod : word;
begin
   Prod := 1;
   for I := 1 to Exposant do Prod := Prod * Base;
   PuisEntier := Prod
end;

procedure LectureDonnees;
begin
   NomCourbe := 'Flocon triangulaire de Von Koch';
   PointsBase := 3;
              XBase[0] := 1;          YBase[0] := 0;
              XBase[1] :=-0.5;        YBase[1] := 0.866025;
              XBase[2] :=-0.5;        YBase[2] :=-0.866025;
              XBase[3] := XBase[0];   YBase[3] := YBase[0];
   PointsGen := 5;
              XGen[0] := 0;           YGen[0] := 0;
              XGen[1] := 0.3333;      YGen[1] := 0;
              XGen[2] := 0.5;         YGen[2] := 0.2887;
              XGen[3] := 0.6666;      YGen[3] := 0;
              XGen[4] := 1;           YGen[4] := 0;
   F1 := -1.1;     F2 := 1.1;     F3 := -1.1;     F4 := 1.1
end;

procedure LectureOrdreCourbe;
begin
   clrscr;
   write ('Ordre de la courbe (0 pour terminer) : ');
   readln (Ordre)
end;

procedure CalculCourbe (O, B, G: byte);
var I,Aux1,Aux2 : word;
    J,M1,M2,K   : word;
    X1,Y1       : real;
begin
   XFract [0] := 0;
   YFract [0] := 0;
   XFract [PuisEntier (G,O)] := 1;
   YFract [PuisEntier (G,O)] := 0;
   for I := 0 to O - 1 do
   begin
      Aux1 := PuisEntier (G,O - I);
      Aux2 := PuisEntier (G,O - I - 1);
      J := 0;
      repeat
         M1 := J + Aux1;
         X1 := XFract [M1] - XFract [J];
         Y1 := YFract [M1] - YFract [J];
         for K := 1 to G-1 do
         begin
            M2 := J + K * Aux2;
            XFract [M2] := X1 * XGen[K] - Y1 * YGen[K] + XFract[J];
            YFract [M2] := Y1 * XGen[K] + X1 * YGen[K] + YFract[J]
         end;
         J := J + Aux1
      until J > PuisEntier (G, O) - 1;
   end
end;

procedure DessineBase;
var I : integer;
begin
   Fenetre (-2, 2, -2, 2);
   Cloture (10, 210, 200, 345);
   DeplaceEn (XBase [0], YBase [0]);
   for I := 1 to PointsBase do TraceVers (XBase [I], YBase [I]);
   PleineCloture;
   OutTextXY (90, 5, 'Base')
end;

procedure DessineGeneratrice;
var I : integer;
begin
   Fenetre (-1, 2, -1.5, 1.5);
   Cloture (10, 210, 20, 170);
   DeplaceEn (XGen [0], YGen [0]);
   for I := 1 to PointsGen - 1 do TraceVers (XGen [I], YGen [I]);
   PleineCloture;
   OutTextXY (65, 165, 'Generatrice')
end;


procedure DessineCourbe (O, B, G: byte);
var Diff1, Diff2 : real;
    M, N         : word;
    XX, YY       : real;
    Chaine       : string;
begin
   Fenetre (F1, F2, F3, F4);
   Cloture (240, 715, 1, 346);
   str (Ordre, Chaine);
   Chaine := concat (NomCourbe, '   Ordre=', Chaine);
   DeplaceEn (1.1*F1, F4);
   OutText (Chaine);
   DeplaceEn (XBase [0], YBase [0]);
   for M := 0 to B-1 do
   begin
      Diff1 := XBase [M+1] - XBase [M];
      Diff2 := YBase [M+1] - YBase [M];
      for N := 0 to PuisEntier (G,O) do
      begin
         XX := Diff1 * XFract [N] - Diff2 * YFract [N] + XBase [M];
         YY := Diff2 * XFract [N] + Diff1 * YFract [N] + YBase [M];
         TraceVers (XX, YY)
      end
   end
end;

function TestGrandeur: boolean;
begin
   if Ordre * ln(PointsGen - 1) > ln(Limite)
      then TestGrandeur := false
      else TestGrandeur := true
end;

BEGIN
   LectureDonnees;
   LectureOrdreCourbe;
      while (Ordre <> 0) and TestGrandeur do
      begin
         if TestGrandeur
         then begin
                 CalculCourbe (Ordre, PointsBase, PointsGen - 1);
                 EcranGraphique;
                 DessineBase;
                 DessineGeneratrice;
                 DessineCourbe (Ordre, PointsBase, PointsGen - 1);
                 Attente;
                 EcranTexte;
                 LectureOrdreCourbe
              end
         else
            begin
               writeln ('Dpassement de capacit des tables...');
               writeln ('Enfoncez ENTER pour continuer.');
               Attente
            end;
      end
END.
