program HANOIGRA;            { Tour de Hanoi graphiques }
Uses crt, graph, graph2D;
const Duree  = 100;
      IncHor = 10;
      IncVer = 1;
var Pile1       : array [1..10] of byte;
    Pile2       : array [1..10] of byte;
    Pile3       : array [1..10] of byte;
    CadrePile1  : array [1..10, 1..4] of integer;
    CadrePile2  : array [1..10, 1..4] of integer;
    CadrePile3  : array [1..10, 1..4] of integer;
    Pointeur, Pointeur1, Pointeur2, Pointeur3 : byte;
    NbreDisques, NoDisque                     : byte;
    HauteurPile, HauteurMax                   : byte;
    TrajetHorizontal, NoTransfert             : integer;
    C1, C2, C3, C4                            : integer;

procedure TraceCadre (C: byte);
begin
   Couleur (C);
   DeplaceEn (C1, C3);
   TraceVers (C2, C3);
   TraceVers (C2, C4);
   TraceVers (C1, C4);
   TraceVers (C1, C3)
end;

procedure Transfert (N,Origine,Destination,Intermediaire:integer);

   procedure DeplaceCadreVersHaut;
   begin
      TraceCadre (Noir);
      Couleur (Blanc);
      DeplaceEn (C1, C3);
      TraceVers (C2, C3);           {Redessine le bord infrieur}
      repeat
         C3 := C3 + IncVer;
         C4 := C4 + IncVer;
         TraceCadre (Blanc);
         delay (Duree);
         TraceCadre (Noir)
      until C4 >= HauteurMax
   end;

   procedure DeplaceCadreHorizontalement;
   var Inc : integer;
   begin
      if (Destination - Origine) > 0
         then Inc := IncHor  else Inc := -IncHor;
      repeat
         TraceCadre (Noir);
         C1 := C1 + Inc;
         C2 := C2 + Inc;
         TraceCadre (Blanc);
         Delay(Duree)
      until C1 = TrajetHorizontal
   end;

   procedure DeplaceCadreVersBas;
   begin
      repeat
         TraceCadre (Noir);
         C3 := C3 - IncVer;
         C4 := C4 - IncVer;
         TraceCadre (Blanc);
         Delay(Duree)
      until C4 <= HauteurPile
   end;

   procedure DeplaceDisque (Oigine, Destination : integer);
   var S1, S2, S3 : string;
   begin
      Bar (10, 15, 700, 40);
      NoTransfert := NoTransfert  +  1;
      str (NoTransfert:4, S1);
      str (Origine:1, S2);
      str (Destination:1, S3);
      OutTextXY (5,25,S1+ ')   Transferer un disque de la tour '
                               + S2 + ' vers la tour ' + S3);
      case Origine of
         1: begin
               NoDisque := Pile1 [Pointeur1];
               Pointeur1 := Pointeur1 - 1;
               C1 := CadrePile1 [NoDisque, 1];
               C2 := CadrePile1 [NoDisque, 2];
               C3 := CadrePile1 [NoDisque, 3];
               C4 := CadrePile1 [NoDisque, 4]
            end;
         2: begin
               NoDisque := Pile2 [Pointeur2];
               Pointeur2 := Pointeur2 - 1;
               C1 := CadrePile2 [NoDisque, 1];
               C2 := CadrePile2 [NoDisque, 2];
               C3 := CadrePile2 [NoDisque, 3];
               C4 := CadrePile2 [NoDisque, 4]
            end;
         3: begin
               NoDisque := Pile3 [Pointeur3];
               Pointeur3 := Pointeur3 - 1;
               C1 := CadrePile3 [NoDisque, 1];
               C2 := CadrePile3 [NoDisque, 2];
               C3 := CadrePile3 [NoDisque, 3];
               C4 := CadrePile3 [NoDisque, 4]
            end
      end;
      TrajetHorizontal := (Destination - Origine) * 30 + C1;
      DeplaceCadreVersHaut;
      DeplaceCadreHorizontalement;

      Case Destination of
         1: begin
               Pointeur1 := Pointeur1 + 1;
               HauteurPile := Pointeur1
            end;
         2: begin
               Pointeur2 := Pointeur2 + 1;
               HauteurPile := Pointeur2
            end;
         3: begin
               Pointeur3 := Pointeur3 + 1;
               HauteurPile := Pointeur3
            end
      end;

      DeplaceCadreVersBas;

      Case Destination of
         1: begin
               Pile1 [Pointeur1] := NoDisque;
               CadrePile1 [NoDisque, 1] := C1;
               CadrePile1 [NoDisque, 2] := C2;
               CadrePile1 [NoDisque, 3] := C3;
               CadrePile1 [NoDisque, 4] := C4
            end;
         2: begin
               Pile2 [Pointeur2] := NoDisque;
               CadrePile2 [NoDisque, 1] := C1;
               CadrePile2 [NoDisque, 2] := C2;
               CadrePile2 [NoDisque, 3] := C3;
               CadrePile2 [NoDisque, 4] := C4
            end;
         3: begin
               Pile3 [Pointeur3] := NoDisque;
               CadrePile3 [NoDisque, 1] := C1;
               CadrePile3 [NoDisque, 2] := C2;
               CadrePile3 [NoDisque, 3] := C3;
               CadrePile3 [NoDisque, 4] := C4
            end
      end
   end;

begin
   if N>0
   then begin
          Transfert (N-1,Origine,Intermediaire,Destination);
          DeplaceDisque (Origine, Destination);
          Transfert (N-1,Intermediaire,Destination,Origine)
        end
end;

procedure EntreeDesDonnees;
begin
   ClrScr;
   write ('Entrez le nombre de disques initial: ');
   readln (NbreDisques)
end;

procedure Initialisation;
var L : byte;
begin
   HauteurMax  := NbreDisques + 2;
   NoTransfert := 0;

   (* Initialisation de la table des fentres de la piles 1 *)

   CadrePile1 [1, 1] := 0;
   CadrePile1 [1, 2] := 20;
   CadrePile1 [1, 3] := 0;
   CadrePile1 [1, 4] := 1;
   for L := 2 to NbreDisques do
   begin
      CadrePile1 [L, 1] := CadrePile1 [L - 1, 1] + 1;
      CadrePile1 [L, 2] := CadrePile1 [L - 1, 2] - 1;
      CadrePile1 [L, 3] := CadrePile1 [L - 1, 3] + 1;
      CadrePile1 [L, 4] := CadrePile1 [L - 1, 4] + 1
   end;

  (* Initialisation des pointeurs de piles *)

  Pointeur1 := NbreDisques;
  Pointeur2 := 0;
  Pointeur3 := 0;

  (* Initialisation des tables des numeros de disques des piles *)

  for L := 1 to NbreDisques do
  begin
     Pile1 [L] := L;
     Pile2 [L] := 0;
     Pile3 [L] := 0
  end
end;

procedure DessinInitial;
var I:byte;
begin
   EcranGraphique;
   Fenetre (0, 80, 0, 20);
   Cloture (0, MaxX, 0, MaxY);
   Couleur (Blanc);
   SetTextStyle (SmallFont, HorizDir, 7);
   SetTextJustify (LeftText, CenterText);
   SetFillStyle (EmptyFill, 0);

   DeplaceEn (0, 0);
   TraceVers (80, 0);
   for I := 1 to NbreDisques do
   begin
      C1 := CadrePile1 [I, 1];
      C2 := CadrePile1 [I, 2];
      C3 := CadrePile1 [I, 3];
      C4 := CadrePile1 [I, 4];
      TraceCadre (Blanc)
   end
end;

BEGIN
   EntreeDesDonnees;
   Initialisation;
   DessinInitial;
   Transfert (NbreDisques, 1, 3, 2);
   Attente;
   EcranTexte
END.
