program Henon4;

(*  Une trajectoire  la fois avec dplacements du curseur par flches.
    Pour dessiner une trajectoire on frappe la touche D une ou plusieurs fois
    Pour terminer on frappe la touche ESC.
*)

uses Crt, Graph, Graph2D;

var F1, F2, F3, F4 : real;
    Angle, X, Y    : real;
    NbreIter       : integer;
    Cosinus, Sinus : real;
    Cur            : pointer;
    XCur, YCur     : integer;

procedure EntreeDonnees;
begin
   clrscr;
   writeln ('ATTRACTEURS  DE  HENON');
   writeln ('======================');
   writeln;
   write ('Fenetre: ');
   readln (F1, F2, F3, F4);
   write ('Valeur de l''angle en radians : ');
   readln (Angle);
   Cosinus := cos (Angle);
   Sinus := sin (Angle);
   write ('Nombre d''itrations <1000 : ');
   readln (NbreIter)
end;

procedure CreationCurseur;
var  Xg, Xd, Yb, Yh : integer;
     Taille         : word;
begin
   Xg := 0;     Xd := 10;   Yb := 0;    Yh := 10;
   MoveRel (5,0);     LineRel(-5,0);      LineRel (0,5);
   MoveRel (10, 5);   LineRel (-10,-10);
   Taille := ImageSize (Xg, Yb, Xd, Yh);
   Getmem (Cur, Taille);
   GetImage (Xg, Yb, Xd, Yh, Cur^);
   PutImage (Xg, Yb, Cur^, XORPut)
end;

procedure AttracteurHenon (X, Y: real);
var Aux : real;
    N   : integer;
begin
   for N:=0 to NbreIter do
   begin
      DeplaceEn (X, Y);
      TraceVers (X, Y);
      Aux := X;
      if X < 1E19 then
      begin
         X := X * Cosinus - (Y - X * X) * Sinus;
         Y := Aux * Sinus + (Y - Aux * Aux) * Cosinus
      end
   end;
   Bip
end;

procedure PlaceCurseur;
const PasX = 5;
      PasY = 5;
var   X, Y       : integer;
      Ch         : char;
      XPos, YPos : real;
begin
   X := 220;   Y := 165;   PutImage (X, Y, Cur^, XORPut);    MoveTo (X, Y);
   repeat
      Ch := ReadKey;
      if Ch = #0
      then begin
              Ch := ReadKey;
              case Ch of
                #72 : begin    (* flche vers le haut *)
                         PutImage (X, Y, Cur^, XORput);
                         Y := Y - PasY;
                         PutImage (X, Y, Cur^, XORput)
                      end;
                #75 : begin    (* flche vers la gauche *)
                         PutImage (X, Y, Cur^, XORput);
                         X := X - PasX;
                         PutImage (X, Y, Cur^, XORput)
                      end;
                #77 : begin    (* flche vers la droite *)
                         PutImage (X, Y, Cur^, XORput);
                         X := X + PasX;
                         PutImage (X, Y, Cur^, XORput)
                      end;
                #80 : begin    (* flche vers le bas *)
                         PutImage (X, Y, Cur^, XORput);
                         Y := Y + PasY;
                         PutImage (X, Y, Cur^, XORput)
                      end
              end;
              MoveTo (X, Y)
           end
      else if UpCase (Ch) = 'D'
              then begin
                      XPos :=  GetX / XRapport + XgFen;
                      YPos := -GetY / YRapport + YhFen;
                      PutImage (X, Y, Cur^, XORput);
                      AttracteurHenon (XPos, YPos);
                      PutImage (X, Y, Cur^, XORput)
                   end
   until UpCase(Ch) = chr(27)
end;

procedure InitGraphisme;
begin
   EcranGraphique;
   CreationCurseur;
   Fenetre (F1, F2, F3, F4);
   Cloture (140, 580, 15, 345);
   Axes;
   Gradue (0.1, 0.1);
end;

BEGIN
   EntreeDonnees;
   InitGraphisme;
   PlaceCurseur;
   EcranTexte
END.
