program INVERSE;          { Inversion de courbes polaires }

Uses Crt, Graph, Graph2D;

const Pas = 0.025;
      Lim = 6.2832;       {2 Pi}

var Puis : real;

function Rho (T : real) : real;
begin
   Rho := 1/(1+cos(T))
end;

procedure LectureDonnees;
begin
   ClrScr;
   write ('Puissance de l''inversion <> 0 : ');
   readln (Puis)
end;

procedure DessineCourbe;
var X, Y, T : real;
begin
   T := 1E-20;  {Evite une division par 0 dans le calcul de Rho}
   X := Rho(T);
   Y := 0;
   DeplaceEn (X, Y);
   repeat
      begin
         T := T + Pas;
         X := Rho(T) * cos(T);
         Y := Rho(T) * sin(T);
         TraceVers (X, Y)
      end
   until T>=Lim
end;

procedure DessineCourbeInverse;
var T, R1, R2, X, Y : real;
begin
   T  := 1E-20;
   R1 := Rho(T);
   If R1=0 then R2 := Puis / 1E-37 else R2 := Puis / R1;
   X := R2 * cos(T);
   Y := R2 * sin(T);
   DeplaceEn (X, Y);
   repeat
      begin
         T  := T + Pas;
         R1 := Rho(T);
         R2 := Puis / R1;
         X  := R2 * cos(T);
         Y  := R2 * sin(T);
         TraceVers (X, Y)
      end
   until T>=Lim
end;

BEGIN
  LectureDonnees;
  EcranGraphique;
  Fenetre (-5, 5, -5, 5);
  Cloture (140, 580, 15, 345);
  TraceBordure;
  Axes;
  Gradue (1, 1);
  if Puis > 0 then CerclePointille (0, 0, sqrt(Puis));
  DessineCourbe;
  DessineCourbeInverse;
  Attente;
  Ecrantexte
END.
