program JULIA;   {Grace a des ZOOM sur l'ensemble de MANDELBROT}

Uses Crt, Graph, DOS, GRAPH2D;

var X1, X2, Y1, Y2 : real;
    IncX, IncY     : real;
    Limite         : byte;
    P, Q           : real;

const BaseEcran  = 460;
      HautEcran  = 346;
      IncLigne   = 10;
      IncColonne = 10;

procedure Initialisation;
begin
   clrscr;
   writeln (' ':10,'LES ENSEMBLES DE JULIA');
   writeln (' ':10,'======================');
   gotoXY (1,10);
   writeln ('Entrez une fentre carre:');
   gotoXY (1,12);
   write ('Intervalle sur l''axe rel ........ [X1, X2]  ? ');
   readln (X1, X2);
   write ('Intervalle sur l''axe imaginaire .. [Y1, Y2]  ? ');
   readln (Y1, Y2);
   write ('Nombre limite d''itrations ......... Limite  ? ');
   readln (Limite);
   write ('Coordonne du point de dpart ....... (P,Q)  ? ');
   readln (P, Q);
   IncX := (X2 - X1) / BaseEcran;
   IncY := (Y2 - Y1) / HautEcran;
   SetTime (0, 0, 0, 0);
end;

procedure AffichageDonnees;
var Hour, Min, Sec, Sec100 : word;
    Ch, Ch1                : string;
begin
   GetTime (Hour, Min, Sec, Sec100);
   Couleur (Blanc);      SetTextStyle (SmallFont, HorizDir, 6);
   str (X1:8:5,Ch);Ch:=concat('X1   = ',Ch);OutTextXY (550,50,Ch);
   str (X2:8:5,Ch);Ch:=concat('X2   = ',Ch);OutTextXY (550,80,Ch);
   str (Y1:8:5,Ch);Ch:=concat('Y1   = ',Ch);OutTextXY (550,110,Ch);
   str (Y2:8:5,Ch);Ch:=concat('Y2   = ',Ch);OutTextXY (550,140,Ch);
   str (Limite:4,Ch);Ch:=concat('Lim  = ',Ch);OutTextXY (550,170,Ch);
   str (P:8:5,Ch);Ch:=concat('P    = ',Ch);OutTextXY (550,200,Ch);
   str (Q:8:5,Ch);Ch:=concat('Q    = ',Ch);OutTextXY (550,230,Ch);
   str (Hour:2, Ch);     str (Min:2, Ch1);
   Ch:=concat('Temps=',Ch,' H ',Ch1,' M');OutTextXY (550, 260, Ch)
end;

procedure EnsembleJulia;
var Ligne, Colonne, Compt     : integer;
    P0, Q0, Module, X, Y, Aux : real;
begin
   Colonne := 0;
   while Colonne <= BaseEcran do
   begin
      Ligne := 0;
      while Ligne <= (HautEcran div 2) do
      begin
         X := X1 + Colonne * IncX;
         Y := Y1 + Ligne * IncY;
         Compt := 0;
         Module := 0;
         while (Compt <= Limite) and (Module <=4) do
         begin
            Aux := X;
            X := sqr(X) - sqr(Y) + P;
            Y := 2 * Y * Aux + Q;
            Module := sqr(X) + sqr(Y);
            Inc(Compt)
         end;
         if Module > 4 then
         begin
            Couleur (Compt mod (NbreCouleurs + 1));
            MoveTo (Colonne, HautEcran - Ligne);
            LineTo (Colonne, HautEcran - Ligne);
            MoveTo (BaseEcran - Colonne, Ligne);
            LineTo (BaseEcran - Colonne, Ligne)
         end;
         Ligne := Ligne + IncLigne
      end;
      Colonne := Colonne + IncColonne
   end
end;

BEGIN
   Initialisation;
   EcranGraphique;
   EnsembleJulia;
   AffichageDonnees;
   Attente;
   Ecrantexte
END.
