(* Pour 0<C<1      l'attracteur est l'origine des axes
        24<C<128   il n'y a plus de point fixe stable
   Il suffit de frapper une touche pour arrter le trac du dessin
   Certaines valeurs feront que l'on sort de la zone logique de dessin
   ce qui provoque une erreur dans l'unit GRAPH3D.
*)

program LORENZ;

Uses Crt, Graph, GRAPH3D;

var X, Y, Z, A, B, C : real;
    dX, dY, dZ, dT   : real;
    Ch               : char;
    Premier          : boolean;

procedure EntreeDesDonnees;
begin
   ClrScr;
   writeln ('ATTRACTEUR DE LORENZ');
   writeln ('====================');
   gotoXY (1,5);
   write ('Valeur du paramtre C:');
   readln (C);
   A := 10;   B := 8/3;
   X := 1; Y := 1; Z := 1;
   dT := 0.01;
   Premier := true;
end;

procedure AttracteurDeLorenz;
begin
   Ch := ' ';
   repeat
      dX := A * (Y - X) * dT;
      dY := (C * X - Y - X*Z) * dT;
      dZ := (-B * Z + X * Y) * dT;
      if Premier then begin
                        Premier := false;
                        DeplaceEn (dX, dY, dZ)
                     end;
      TraceVers (dX, dY, dZ);
      X := X + dX;
      Y := Y + dY;
      Z := Z + dZ;
      if KeyPressed then Ch := readKey;
   until Ch <> ' ';
end;

procedure Affichage (Titre: string);
begin
   SetTextStyle (SmallFont, HorizDir, 5);
   OutTextXY (250, 335, 'PROJECTION ' + Titre);
end;

BEGIN
   EntreeDesDonnees;
   EcranGraphique;
   Cloture (0, MaxX, 0, MaxY);
   Projection := Parallele;
   Theta := 45;
   Phi   := 35.26439;
   DE := 10;
   InitialiseProjection;
   AxesPointilles;
   AttracteurDeLorenz;
   EcranTexte
END.
