program MANDEL;

Uses Graph, GRAPH2D;

var X1, X2, Y1, Y2 : real;
    IncX, IncY     : real;
    Limite         : byte;

const BaseEcran  = 460;
      HautEcran  = 346;
      IncLigne   = 10;
      IncColonne = 10;

procedure Initialisation;
begin
   X1 := -2;
   X2 := 0.5;
   Y1 := -1.25;
   Y2 := 1.25;
   Limite := 50;
   IncX := (X2 - X1) / BaseEcran;
   IncY := (Y2 - Y1) / HautEcran
end;

procedure Mandelbrot;
var Ligne, Colonne, Compt     : integer;
    P0, Q0, Module, X, Y, Aux : real;
begin
   Colonne := 0;
   while Colonne <= BaseEcran do
   begin
      P0 := X1 + Colonne * IncX;
      Ligne := 0;
      while Ligne <= (HautEcran div 2) do
      begin
         Q0 := Y1 + Ligne * IncY;
         X := 0;
         Y := 0;
         Compt := 1;
         Module := 0;
         while (Compt <= Limite) and (Module < 4) do
         begin
            Aux := X;
            X := sqr(X) - sqr(Y) + P0;
            Y := 2 * Y * Aux + Q0;
            Module := sqr(X) + sqr(Y);
            Inc(Compt)
         end;
         if Module < 4 then
            begin
               MoveTo (Colonne, Ligne);
               LineTo (Colonne, Ligne);
               MoveTo (Colonne, HautEcran - Ligne);
               LineTo (Colonne, HautEcran - Ligne)
            end;
         Ligne := Ligne + IncLigne
      end;
      Colonne := Colonne + IncColonne
   end
end;

BEGIN
   Initialisation;
   EcranGraphique;
   Mandelbrot;
   Attente;
   Ecrantexte
END.



