program Mandzoom;     (* ZOOM sur l'ensemble de MANDELBROT *)

Uses Crt, Graph, DOS, GRAPH2D;

var X1, X2, Y1, Y2 : real;
    IncX, IncY     : real;
    Limite         : integer;

const BaseEcran  = 460;
      HautEcran  = 346;
      IncLigne   = 10;
      IncColonne = 10;

procedure Initialisation;
begin
   clrscr;
   writeln (' ':10,'ZOOM SUR L''ENSEMBLE DE MANDELBROT');
   writeln (' ':10,'=================================');
   gotoXY (1,10);
   writeln ('Entrez une fentre carre:');
   gotoXY (1,12);
   write ('Intervalle sur l''axe rel ........ [X1, X2]  ? ');
   readln (X1, X2);
   write ('Intervalle sur l''axe imaginaire .. [Y1, Y2]  ? ');
   readln (Y1, Y2);
   write ('Nombre limite d''iterations ......... Limite  ? ');
   readln (Limite);
   IncX := (X2 - X1) / BaseEcran;
   IncY := (Y2 - Y1) / HautEcran;
   SetTime (0, 0, 0, 0);
end;

procedure AffichageDonnees;
var Hour, Min, Sec, Sec100 : word;
    Ch, Ch1                : string;
begin
   GetTime (Hour, Min, Sec, Sec100);
   SetColor (Blanc);
   MoveTo (0,0);LineTo (MaxX,0);LineTo (MaxX, MaxY);LineTo (0, MaxY);
   LineTo(0,0);MoveTo (460,0);LineTo( 460, MaxY);
   SetTextStyle (SmallFont, HorizDir, 6);
   str (X1:10:7,Ch);Ch:=concat('X1   = ',Ch);OutTextXY (520,100,Ch);
   str (X2:10:7,Ch);Ch:=concat('X2   = ',Ch);OutTextXY (520,130,Ch);
   str (Y1:10:7,Ch);Ch:=concat('Y1   = ',Ch);OutTextXY (520,160,Ch);
   str (Y2:10:7,Ch);Ch:=concat('Y2   = ',Ch);OutTextXY (520,190,Ch);
   str (Limite:4,Ch);Ch:=concat('Lim  = ',Ch);OutTextXY (520,220,Ch);
   str (Hour:2, Ch);
   str (Min:2, Ch1);
   Ch := concat ('Temps=',Ch,' H ',Ch1,' M');
   OutTextXY (520, 250, Ch)
end;

procedure Mandelbrot;
var Ligne, Colonne, Compt     : integer;
    P0, Q0, Module, X, Y, Aux : real;
begin
   Colonne := 0;
   while Colonne <= BaseEcran do
   begin
      P0 := X1 + Colonne * IncX;
      Ligne := 0;
      while Ligne <= HautEcran do
      begin
         Q0 := Y1 + Ligne * IncY;
         X := 0;
         Y := 0;
         Compt := 1;
         Module := 0;
         while (Compt <= Limite) and (Module < 4) do
         begin
            Aux := X;
            X := sqr(X) - sqr(Y) + P0;
            Y := 2 * Y * Aux + Q0;
            Module := sqr(X) + sqr(Y);
            Inc(Compt)
         end;
         if Module > 4 then
            begin
               Couleur (Compt mod NbreCouleurs);
               MoveTo (Colonne, HautEcran - Ligne);
               LineTo (Colonne, HautEcran - Ligne)
            end;
         Ligne := Ligne + IncLigne
      end;
      Colonne := Colonne + IncColonne;
   end
end;

BEGIN
   Initialisation;
   EcranGraphique;
   Mandelbrot;
   AffichageDonnees;
   Attente;
   Ecrantexte
END.
