program MULTIFON;      { Courbes Y=F(X) + POLAIRES + PARAMETRIQUES }

uses Crt, Graph, Graph2D;

var A, B, Pas, UX, UY, X, Y : real;
    F1, F3, F2, F4          : real;
    C1, C3, C2, C4          : integer;
    TraceAxes, GradueAxes   : char;

    ValDepart, ValArrivee                : real;
    Xdepart, Ydepart, Xcourant, Ycourant : real;
    Increment, Periode, RayonMax, Theta  : real;
    Genre, Choix                         : char;

function F(X: real) : real;     { quation cartsienne }
begin
   F := puissance(x*x*x - 3*x + 2,1/3)
end;

function Rho (T : real) : real; { quation polaire }
begin
     Rho := cos(9*T / 4) + 7 / 3
end;

function FX (T: real) : real;   { quations paramtriques }
begin
   FX := sin(5*T) * cos(T)
end;

function FY (T: real) : real;   { quations paramtriques }
begin
   FY := sin(5*T) * sin(4*T)
end;

procedure RecherchePeriode;
var R, Diff1, Diff2, Max : real;
begin
   Max     := 200 * Pi;
   Periode := 0;
   case Genre of
     '2': begin
             Xdepart := Rho (0);
             YDepart := 0
          end;
     '3': begin
             Xdepart := FX(0);
             Ydepart := FY(0)
          end
   end;
   repeat
      Periode  := Periode  +  2 * Pi;
      case Genre of
        '2': begin
                R := Rho (Periode);
                Xcourant :=  R * cos (Periode);
                Ycourant :=  R * sin (Periode)
             end;
        '3': begin
                Xcourant :=  FX(Periode);
                Ycourant :=  FY(Periode)
             end
      end;
      Diff1    := abs(Xcourant - Xdepart);
      Diff2    := abs(Ycourant - Ydepart)
   Until ((Diff1 < 1E-6) and (Diff2 < 1E-6)) or (Periode > Max)
end;

procedure RechercheRayonMax;
var  T, R : real;
begin
   RayonMax := 0;
   T := ValDepart;
   while T<= ValArrivee do
   begin
      case Genre of
        '2': begin
                R := Rho (Periode);
                Xcourant :=  R * cos (Periode);
                Ycourant :=  R * sin (Periode)
             end;
        '3': begin
                Xcourant := FX(T);
                Ycourant := FY(T)
             end
      end;
      if abs(Xcourant) > RayonMax then RayonMax := abs(Xcourant);
      if abs(Ycourant) > RayonMax then RayonMax := abs(Ycourant);
      T := T + Increment
   end;
   RayonMax := 1.1 * RayonMax
end;

procedure Entree;
var Coeff: real;
begin
    ClrScr;
    gotoxy(25, 1);
    writeln ('TRACE DE COURBES PLANES');
    gotoxy(25, 2);
    writeln ('=======================');
    gotoxy(1, 5);
    write ('Vous devez entrer les donnes en RADIANS et ');
    writeln ('crire la fonction  tudier');
    writeln ('en dbut de programme.');writeln;
    HighVideo;
    writeln (' ':20,'[1] F (X) pour une cartsienne');
    writeln (' ':20,'[2] Rho (T) pour une polaire');
    writeln (' ':20,'[3] FX (T) et FY (T) pour une paramtrique');
    NormVideo;
    gotoxy(1, 12);
    write ('Quel est le type de courbe choisi [1,2,3] :');
    readln (Genre);
    gotoXY (1,15);
    case Genre of
      '1'     :begin
                  write ('Intervalle d''tude [A,B] et PAS:');
                  readln (A, B, Pas);
                  writeln;
                  write ('Entrez la fenetre:');
                  readln (F1, F2, F3, F4);
                  writeln;
                  write ('Faut-il tracer les axes (O/N):');
                  readln (TraceAxes);
                  writeln;
                  if upCase(TraceAxes) = 'O'
                     then begin
                             write ('Faut-il les graduer (O/N):');
                             readln (GradueAxes);
                             writeln;
                             if UpCase(GradueAxes) = 'O'
                                then begin
                                        write ('Unit sur X:');
                                        readln (UX);
                                        write ('Unit sur Y:');
                                        readln (UY)
                                     end
                          end;
               end;
      '2','3' :begin
                  write ('La fonction est-elle priodique (O/N): ');
                  readln (Choix);
                  if UpCase(Choix) ='O'
                  then begin
                          write ('Priode (0 si inconnue): ');
                          readln (Periode);
                          if Periode = 0 then RecherchePeriode;
                          ValDepart := 0;
                          ValArrivee := Periode
                       end
                  else begin
                          write ('Intervalle d''tude [A,B]: ');
                          readln (ValDepart, ValArrivee)
                       end;
                  write ('Pas d''incrmentation: ');
                  readln (Increment);
                  write  ('Rayon maximum (0 si inconnu): ');
                  readln (RayonMax);
                  if RayonMax = 0
                     then RechercheRayonMax
                     else RayonMax := 1.1 * RayonMax
               end
        end
end;

procedure TraceCourbe1;
var X, Y: real;
begin
   if upcase(TraceAxes) = 'O' then Axes;
   if upCase(GradueAxes) = 'O' then Gradue (UX, UY);
   X := A;
   Y := F(X);
   DeplaceEn (X, Y);
   repeat
      Y := F (X);
      TraceVers (X, Y);
      X := X + Pas
   until X > B
end;

procedure TraceCourbe23;
var X1, Y1, X2, Y2, T, R : real;
begin
   T  := ValDepart;
   case Genre of
        '2': begin
                R  := Rho (T);
                X1 := R * cos (T);
                Y1 := R * sin (T)
             end;
        '3': begin
                X1 := FX(T);
                Y1 := FY(T)
             end
   end;
   DeplaceEn (X1, Y1);
   while T <= ValArrivee do
      begin
         T  := T + Increment;
         case Genre of
              '2': begin
                      R  := Rho (T);
                      X2 := R * cos (T);
                      Y2 := R * sin (T)
                   end;
              '3': begin
                      X2 := FX(T);
                      Y2 := FY(T)
                   end
         end;
         TraceVers (X2, Y2)
      end
end;

procedure Affichage1;
var S1, S2, S3, S4, S5, S6, S7, S8, S9 : string;
begin
   str (F1:6:2, S1);     str (F2:6:2, S2);     str (F3:6:2, S3);
   str (F4:6:2, S4);     str (A :6:2, S5);     str (B :6:2, S6);
   str (Pas:6:2, S7);    str (UX:6:2, S8);     str (UY:6:2, S9);
   Cloture (0, MaxX, 0, 11);
   OutTextXY (0, 0, 'F(' + S1 + ',' + S2 + ',' + S3 + ',' + S4 + ')'
                  + '   A=' + S5 + '   B=' + S6 + '   Pas=' + S7
                  + '   UX=' + S8 + '   UY=' + S9)
end;

procedure Affichage23;
var S1, S2, S3 : string;
begin
   str (ValDepart:8:4, S1);
   str (ValArrivee:8:4, S2);
   str (Increment:6:3, S3);
   Cloture (0, MaxX, 0, 11);
   OutTextXY (70,0,'Valeur depart='+S1+'     Valeur Arrivee='+S2+
                   '     Increment=' + S3)
end;

BEGIN
   Entree;
   EcranGraphique;
   case Genre of
      '1'    : begin
                  Fenetre (F1, F2, F3, F4);
                  Cloture (0, MaxX, 15, MaxY);
                  TraceBordure;
                  TraceCourbe1;
                  Affichage1
               end;
      '2','3': begin
                  Fenetre (-RayonMax, RayonMax, -RayonMax, RayonMax);
                  Cloture (140, 580, 15, 345);
                  TraceBordure;
                  TraceCourbe23;
                  Affichage23
               end
   end;
   Attente;
   Ecrantexte
END.
