program MULTIPOL;           { Famille de courbes polaires }

uses Crt, Graph, Graph2D;

Const  Increment = 0.05;

var A, B, I, N : integer;
    Periode    : real;
    Ch         : char;

function Rho (T: real) : real;
begin
  Rho:= sin(4 * T)
end;

procedure RecherchePeriode;
var R, R1, R2, Diff1, Diff2, Max         : real;
    Xdepart, Ydepart, Xcourant, Ycourant : real;
begin
      Max:=200 * Pi;
      Periode:=0;
      Xdepart:=Rho(0);
      Ydepart:=0;
      repeat
         Periode:=Periode + 2 * Pi;
         R:=Rho(Periode);
         Xcourant:= R * cos(Periode);
         Ycourant:= R * sin(Periode);
         Diff1:=abs(Xcourant - Xdepart);
         Diff2:=abs(Ycourant - Ydepart)
      until ((Diff1 < 1E-6) and (Diff2 < 1E-6)) or (Periode > Max)
end;

procedure TraceCourbe;
var X1, Y1, X2, Y2, Theta :real;
begin
    Theta:=0 ;
    X1:=Rho(Theta) * cos(Theta) * cos(A * Theta);
    Y1:=Rho(Theta) * sin(Theta) * sin(B * Theta);
    DeplaceEn (X1, Y1);
    while Theta <= Periode do
       begin
          Theta:=Theta + Increment;
          X2:=Rho(Theta) * cos(Theta) * cos(A * Theta);
          Y2:=Rho(Theta) * sin(Theta) * sin(B * Theta);
          TraceVers (X2, Y2)
       end
end;

BEGIN
    EcranGraphique;
    Fenetre (-1.1, 1.1, -1.1, 1.1);
    I:=0;
    for A:=1 to 5 do
    begin
      for B:=1 to 3 do
      begin
         RecherchePeriode;
         I:=(I mod 6) + 1;
         case  I of
            1 : Cloture (5, 225, 175, 345);
            2 : Cloture (247, 472, 175, 345);
            3 : Cloture (494, 719, 175, 345);
            4 : Cloture (5, 225, 0, 170);
            5 : Cloture (247, 472, 0, 170);
            6 : Cloture (494, 719, 0, 170);
         end;
         TraceBordure;
         TraceCourbe;
         if I=6 then begin
                        Attente;
                        EcranGraphique
                     end
      end
    end;
    Attente;
    EcranTexte;
END.

