program PEINTRE;       { Translation automatique }

Uses Crt, Graph, GRAPH3D;

const LimSommets   = 200;
      LimFaces     = 100;
      LimAretes    = 10;
      GrandeValeur = 1E20;

var Sommet           :array [1..LimSommets,1..3] of real;
    StProj           :array [1..LimSommets,1..3] of real;
    StEcran          :array [1..LimSommets,1..2] of integer;
    Face             :array [1..LimFaces,0..LimAretes] of integer;
    MinZ, MaxZ       :array [1..LimFaces] of real;
    Prior            :array [1..LimFaces] of integer;
    DejaDeplace      :array [1..LimFaces] of boolean;
    DejaReussi       :array [1..LimFaces,1..LimFaces] of boolean;
    AretesInvisibles :array [1..LimFaces] of boolean;
    NbreSt, NbreFc   :integer;
    NbreFacesVis     :integer;
    NbreStInitial    :integer;
    TrX, TrY, TrZ    :real;
    NomFic           :string;
    Fichier          :text;
    Translate, Touche:char;
    Oeil1,Oeil2,Oeil3:real;
    TestOK           :boolean;


procedure OuvertureFichierDonnees;
var IOCode: integer;
begin
   {$I-}
   repeat
      ClrScr;
      write ('Nom du fichier DATA  lire: ');
      readln (NomFic);
      NomFic := concat(NomFic, '.TXT');
      assign (Fichier, NomFic);
      reset (Fichier);
      IOCode := IOResult;
      if IOCode <> 0
      then begin
              GotoXY(10,10);
              writeln ('Le fichier ',NomFic,' n''existe pas ....');
              Attente
           end
   until IOCode = 0;
   {$I+}
end;

procedure LectureParametresDeVision;
begin
   writeln;
   write ('Eloignement de l''observateur...... Rho= ');
   readln (Rho);
   write ('Angle Theta en degres ...........Theta= ');
   readln (Theta);
   write ('Angle Phi en degres ...............Phi= ');
   readln (Phi);
   write ('Distance ecran .....................DE= ');
   readln (DE);
   Projection := Perspective;
   InitialiseProjection;
   Oeil1 := Rho * Aux7;
   Oeil2 := Rho * Aux8;
   Oeil3 := Rho * Aux2
end;

procedure InitialisationDesTables;
var I, J: integer;
begin
   fillchar(Sommet, sizeof(Sommet),0);
   fillchar(StProj, sizeof(StProj),0);
   fillchar(StEcran, sizeof(StEcran),0);
   fillchar(Face, sizeof(Face),0);
   fillchar(MinZ, sizeof(MinZ),0);
   fillchar(MaxZ, sizeof(MaxZ),0);
   fillchar(Prior, sizeof(Prior),0);
   for I := 1 to LimFaces do
   begin
      DejaDeplace [I] := false;
      AretesInvisibles [I] := false;
      for J := 1 to LimFaces do DejaReussi [I,J] := false;
   end
end;

procedure TestFaceArriere (var ProduitScalaire: real; I: integer);
var StNo1, StNo2, StNo3    : integer;
    V1, V2, V3, N1, N2, N3 : real;
    P1, P2, P3, Q1, Q2, Q3 : real;
begin
   StNo1 := Face [I,1];
   StNo2 := Face [I,2];
   StNo3 := Face [I,3];
   V1 := Oeil1 - Sommet [StNo1,1];
   V2 := Oeil2 - Sommet [StNo1,2];
   V3 := Oeil3 - Sommet [StNo1,3];
   P1 := Sommet [StNo2,1] - Sommet [StNo1,1];
   P2 := Sommet [StNo2,2] - Sommet [StNo1,2];
   P3 := Sommet [StNo2,3] - Sommet [StNo1,3];
   Q1 := Sommet [StNo3,1] - Sommet [StNo1,1];
   Q2 := Sommet [StNo3,2] - Sommet [StNo1,2];
   Q3 := Sommet [StNo3,3] - Sommet [StNo1,3];
   N1 := P2 * Q3 - Q2 * P3;
   N2 := P3 * Q1 - Q3 * P1;
   N3 := P1 * Q2 - Q1 * P2;
   ProduitScalaire := V1 * N1 + V2 * N2 + V3 * N3
end;

procedure InitialiseExtremums (NS, NF: integer);
var Min, Max, Z : real;
    I, NoSt     : integer;
begin
   Min := GrandeValeur;
   Max := -GrandeValeur;
   for I := 1 to NS do
   begin
      NoSt := Face [NF,I];
      Z    := StProj [NoSt,3];
      if Z < Min then Min := Z;
      if Z > Max then Max := Z
   end;
   MinZ [NF] := Min;
   MaxZ [NF] := Max
end;

procedure LectureSommetsEtFaces;
var X, Y, Z         : real;
    ProduitScalaire : real;
    I, J, NS        : integer;
    MiX, MaX        : real;
    MiY, MaY        : real;
    MiZ, MaZ        : real;
begin
   readln (Fichier, NbreSt);
   NbreStInitial := NbreSt;
   MiX := 1E20;  MaX := -1E20;
   MiY := 1E20;  MaY := -1E20;
   MiZ := 1E20;  MaZ := -1E20;
   for I := 1 to NbreSt do
   begin
      readln (Fichier, X,Y,Z);
      if X < MiX then Mix := X;
      if X > MaX then MaX := X;
      if Y < MiY then MiY := Y;
      if Y > MaY then MaY := Y;
      if Z < MiZ then MiZ := Z;
      if Z > MaZ then MaZ := Z
   end;
   TrX := -(MiX + MaX) / 2;
   TrY := -(MiY + MaY) / 2;
   TrZ := -(MiZ + MaZ) / 2;
   reset (Fichier);
   readln (Fichier, NbreSt);
   for I := 1 to NbreSt do
   begin
      readln (Fichier, X,Y,Z);
      X := X + TrX;
      Y := Y + TrY;
      Z := Z + TrZ;
      Sommet [I,1] := X;
      Sommet [I,2] := Y;
      Sommet [I,3] := Z;
      Projette (X, Y, Z);
      StProj [I,1] := XObs;
      StProj [I,2] := YObs;
      StProj [I,3] := ZObs;
      StEcran [I,1] := round(XProj * Echelle + MaxX div 2);
      StEcran [I,2] := round(MaxY div 2 - YProj)
   end;
   NbreFacesVis := 0;
   readln (Fichier, NS);
   while NS <> 0 do
   begin
      NbreFacesVis := NbreFacesVis + 1;
      Face [NbreFacesVis,0] := NS;
      for J:= 1 to NS do readln (Fichier, Face [NbreFacesVis,J]);
      TestFaceArriere (ProduitScalaire, NbreFacesVis);
      if ProduitScalaire >= 0
         then begin
                 Prior [NbreFacesVis] := NbreFacesVis;
                 InitialiseExtremums (NS, NbreFacesVis)
              end
         else NbreFacesVis := NbreFacesVis - 1;
      readln (Fichier, NS)
   end;
   close (Fichier)
end;

procedure BoitesLimitesSelonX (P,Q: integer;var Delta: real);
var I, J, NoSt     : integer;
    XE, YE         : real;
    P1, P2, Q1, Q2 : real;
begin
   NoSt := Face [P,0];
   P1   := GrandeValeur;
   P2   := -GrandeValeur;
   for I := 1 to NoSt do
   begin
      J  := Face [P,I];
      XE := StEcran [J,1];
      if XE < P1 then P1 := XE;
      if XE > P2 then P2 := XE
   end;
   NoSt := Face [Q,0];
   Q1 := GrandeValeur;
   Q2 := -GrandeValeur;
   for I := 1 to NoSt do
   begin
      J  := Face [Q,I];
      XE := StEcran [J,1];
      if XE < Q1 then Q1 := XE;
      if XE > Q2 then Q2 := XE
   end;
   if P2 > Q2 then Delta := P1 - Q2
              else Delta := Q1 - P2
end;

procedure BoitesLimitesSelonY (P,Q: integer; var Delta: real);
var I, J, NoSt     : integer;
    XE, YE         : real;
    P1, P2, Q1, Q2 : real;
begin
   NoSt := Face [P,0];
   P1   := GrandeValeur;
   P2   := -GrandeValeur;
   for I := 1 to NoSt do
   begin
      J  := Face [P,I];
      YE := StEcran [J,2];
      if YE < P1 then P1 := YE;
      if YE > P2 then P2 := YE
   end;
   NoSt := Face [Q,0];
   Q1 := GrandeValeur;
   Q2 := -GrandeValeur;
   for I := 1 to NoSt do
   begin
      J  := Face [Q,I];
      YE := StEcran [J,2];
      if YE < Q1 then Q1 := YE;
      if YE > Q2 then Q2 := YE
   end;
   if P2 > Q2 then Delta := P1 - Q2
              else Delta := Q1 - P2
end;

procedure EquationPlan (P: integer; var A, B, C, D: real);
var S1, S2, S3 : integer;
    X1, Y1, Z1 : real;
    X2, Y2, Z2 : real;
    X3, Y3, Z3 : real;
begin
   S1 := Face[P,1];    S2 := Face[P,2];     S3 := Face[P,3];
   X1 := StProj[S1,1]; Y1 := StProj[S1,2];  Z1 := StProj[S1,3];
   X2 := StProj[S2,1]; Y2 := StProj[S2,2];  Z2 := StProj[S2,3];
   X3 := StProj[S3,1]; Y3 := StProj[S3,2];  Z3 := StProj[S3,3];
   A  := Y1 * (Z2 - Z3) + Y2 * (Z3 - Z1) + Y3 * (Z1 - Z2);
   B  := -X1 * (Z2 - Z3) + X2 * (Z1 - Z3) - X3 * (Z1 - Z2);
   C  := X1 * (Y2 - Y3) - X2 * (Y1 - Y3) + X3 * (Y1 - Y2);
   D  := -X1*(Y2*Z3-Y3*Z2)+X2*(Y1*Z3-Y3*Z1)-X3*(Y1*Z2-Y2*Z1)
end;

function Signe(X: real): integer;
begin
   if X<0 then Signe:=-1 else if X>0 then Signe:=1 else Signe:=0
end;

procedure TestePositionFaces (P1, P2, Sg: integer);
var I, NbreSt, Si : integer;
    X, Y, Z, R    : real;
    A, B, C, D    : real;
begin
   EquationPlan (P2, A, B, C, D);
   I := 0;
   NbreSt := Face [P1,0];
   repeat
      I  := I + 1;
      Si := Face [P1,I];
      X  := StProj[Si,1]; Y := StProj[Si,2]; Z := StProj[Si,3];
      R  := A * X + B * Y + C * Z + D;
      TestOK := false;
      if abs(D) < 1E-9 then D := R;
      if abs(R)<1E-3 then TestOK := true
                     else TestOK := (Signe(R)<>Signe(Sg*D))
   until (I=NbreSt) or not(TestOK)
end;

procedure TriSelonPriorite (Face: integer);
var  I, J, Aux: integer;
begin
   for I := NbreFacesVis downto Face do
      for J := Face + 1 to I do
         if MaxZ [Prior [J]] > MaxZ [Prior [J-1]]
            then begin
                    Aux := Prior [J];
                    Prior [J] := Prior [J-1];
                    Prior [J-1]:= Aux
                 end
end;

procedure ChercheIntersection (P1, P2, Fac: integer);
var A, B, C, D       : real;
    X, Y, Z, R0, R   : real;
    Trouve           : boolean;
    NS, St, NouvSt   : integer;
    NoPointAtteint   : integer;
    XI, YI, ZI       : real;
    Proche1, Proche2 : integer;
    Proche3, Proche4 : integer;
    NouvSt1, NouvSt2 : integer;
    St1, St2         : integer;

    procedure CompareLesSommetsAuPlan (I: integer);
    begin
       Trouve := false;
       repeat
          I  := I + 1;
          if I > NS then I := 1;
          St := Face [P1,I];
          X  := StProj [St,1];
          Y  := StProj [St,2];
          Z  := StProj [St,3];
          R  := A * X + B * Y + C * Z + D;
          if abs(R0) > 1E-3
          then begin
                 if abs(R) > 1E-3
                   then if (Signe(R)<>Signe(R0)) or (abs(R)<1E-3)
                             then Trouve := true
               end
          else if abs(R) > 1E-3 then R0 := R;
       until Trouve;
       NoPointAtteint := I;
       R0 := R
    end;

    procedure CalculeIntersection (St1, St2: integer);
    var X1, Y1, Z1, X2, Y2, Z2, V, R: real;
    begin
       X1 := StProj [St1,1];
       Y1 := StProj [St1,2];
       Z1 := StProj [St1,3];
       EquationPlan (P2, A, B, C, D);
       R  := A * X1 + B * Y1 + C * Z1 + D;
       if abs(R) < 1E-3
          then begin
                  XI := X1;
                  YI := Y1;
                  ZI := Z1
               end
          else begin
                  X2 := StProj [St2,1];
                  Y2 := StProj [St2,2];
                  Z2 := StProj [St2,3];
                  V := -R/(A*(X2-X1)+B*(Y2-Y1)+C*(Z2-Z1));
                  XI := X1 + V * (X2 - X1);
                  YI := Y1 + V * (Y2 - Y1);
                  ZI := Z1 + V * (Z2 - Z1)
               end;
       NbreSt := NbreSt + 1;
       NouvSt := NbreSt;
       StProj [NouvSt,1] := XI;
       StProj [NouvSt,2] := YI;
       StProj [NouvSt,3] := ZI;
       Xproj := DE * XI / ZI;
       YProj := DE * YI / ZI;
       StEcran [NouvSt,1] := round(XProj * Echelle + MaxX div 2);
       StEcran [NouvSt,2] := round(MaxY div 2 - YProj)
    end;

    procedure AjouteNelleFace (Fac: integer);
    var I, F, Cpt, Pr : integer;
    begin
       Inc(NbreFacesVis);
       F := NbreFacesVis;
       Face [F,1] := NouvSt1;
       Cpt := 1;
       I := Proche2 - 1;
       repeat
          I := I + 1;
          if I > Face [P1,0] then I := 1;
          Inc(Cpt);
          Face [F,Cpt] := Face [P1,I];
       until I = Proche3;
       Inc(Cpt);
       Face [F,Cpt] := NouvSt2;
       Face [F,0] := Cpt;
       Prior [F] := F;
       for I := Fac to F
       do begin
             Pr := Prior [I];
             DejaReussi [F,Pr] := DejaReussi [P1,Pr];
             DejaReussi [Pr,F] := DejaReussi [Pr,P1]
          end;
       InitialiseExtremums (Cpt, NbreFacesVis);
       AretesInvisibles [F] := true
    end;

    procedure RemplaceAncienneFace;
    var I, Cpt : integer;
        Aux    : array [0..LimAretes] of integer;
    begin
       Cpt := 1;
       I := Proche3;
       repeat
          I := I + 1;
          if I > Face [P1,0] then I := 1;
          Inc(Cpt);
          Aux [Cpt] :=  Face [P1,I];
       until I = Proche1;
       Inc(Cpt);
       Aux [Cpt] := NouvSt1;
       Aux [1] := NouvSt2;
       Aux [0] := Cpt;
       AretesInvisibles [P1] := true;
       for I := 0 to Cpt do Face [P1,I] := Aux [I];
       InitialiseExtremums (Cpt, P1)
    end;

begin
   Bip;
   EquationPlan (P2, A, B, C, D);
   NS := Face [P1,0];
   St := Face [P1,1];
   X  := StProj [St,1];
   Y  := StProj [St,2];
   Z  := StProj [St,3];
   R0 := A * X + B * Y + C * Z + D;
   CompareLesSommetsAuPlan (1);
   if NoPointAtteint = 1
      then Proche1 := Face [P1,0]
      else Proche1 := NoPointAtteint - 1;
   Proche2 := NoPointAtteint;
   CompareLesSommetsAuPlan (NoPointAtteint);
   if NoPointAtteint = 1
      then Proche3 := Face [P1,0]
      else Proche3 := NoPointAtteint - 1;
   Proche4 := NoPointAtteint;
   St1 := Face [P1,Proche1];   St2 := Face [P1,Proche2];
   CalculeIntersection (St1,St2);
   NouvSt1 := NouvSt;
   St1 := Face [P1,Proche3];   St2 := Face [P1,Proche4];
   CalculeIntersection (St1,St2);
   NouvSt2 := NouvSt;
   AjouteNelleFace (Fac);
   RemplaceAncienneFace
end;

procedure VoirSiParalleles (P1,P2:integer;var Parallele:boolean);
var A1, B1, C1, D1: real;
    A2, B2, C2, D2: real;
begin
   EquationPlan (P1,A1,B1,C1,D1);
   EquationPlan (P2,A2,B2,C2,D2);
   if (abs(A1/A2 - B1/B2) < 1E-6) and (abs(A1/A2 - C1/C2) < 1E-6)
      then Parallele := true
end;

procedure BoucleDesTests;
var FaceCour, FaceSuiv  : integer;
    P, Q, I, J          : integer;
    P1, P2, P3, P4      : real;
    Q1,Q2,Q3,Q4         : real;
    DX, DY              : real;
    TestPrec            : boolean;
    Parallele           : boolean;

    procedure PermutePlans;
    begin
       DejaDeplace [P]:=true;
       DejaReussi [Q,P] := true;
       Prior [FaceCour] := Q;
       Prior [FaceSuiv] := P;
       P := Q;
       Q := Prior [FaceSuiv];
       FaceSuiv := FaceCour
    end;

begin {1}
  for I := 1 to NbreFacesVis do
      for J := 1 to NbreFacesVis do DejaReussi [I,J] := false;
  FaceCour :=1;
  while FaceCour < NbreFacesVis do
  begin {2}
    TriSelonPriorite(FaceCour);
    for I:=FaceCour to NbreFacesVis do DejaDeplace [Prior[I]]:=false;
    P  := Prior [FaceCour];
    FaceSuiv := FaceCour;
    while FaceSuiv < NbreFacesVis do
    begin {3}
      FaceSuiv := FaceSuiv + 1;
      Q  := Prior [FaceSuiv];
      if not(DejaReussi [P,Q])
      then
        begin {4}
          if MAXZ [Q] > MINZ [P]
          then
            begin {5}
              BoitesLimitesSelonX (P, Q, DX);
              if DX < 0
              then
                begin {6}
                  BoitesLimitesSelonY (P, Q, DY);
                  if DY < 0
                  then
                    begin {7}
                      TestePositionFaces (P, Q, 1);
                      if not(TestOK)
                      then
                        begin {8}
                          TestePositionFaces (Q, P, -1);
                          if not(TestOK)
                          then
                            begin {9}
                              TestePositionFaces (Q, P, 1);
                              if (TestOK) and (not(DejaDeplace [Q]))
                              then PermutePlans
                              else
                                begin {10}
                                  TestPrec := TestOK;
                                  TestePositionFaces (P, Q, -1);
                                  Parallele := false;
                                  if (TestOK and TestPrec) then VoirSiParalleles (P,Q,Parallele);
                                  if not(Parallele) then
                                  begin {11}
                                    if (TestOK) and (not(DejaDeplace [Q]))
                                    then PermutePlans
                                    else
                                      begin {12}
                                        if ((TestOK) and (TestPrec))
                                        then PermutePlans
                                        else
                                          begin {13}
                                            if TestOK then ChercheIntersection (Q, P, FaceCour)
                                                      else ChercheIntersection (P, Q, FaceCour);
                                            for I := FaceCour to NbreFacesVis
                                               do DejaDeplace [Prior [I]] := false;
                                            FaceSuiv := FaceSuiv - 1
                                          end {13}
                                      end {12}
                                  end {11}
                                end {10}
                            end {9}
                          else DejaReussi [P,Q]:=true;
                        end {8}
                      else DejaReussi [P,Q]:=true;
                    end {7}
                  else
                     begin
                        DejaReussi [P,Q] := true;
                        DejaReussi [Q,P] := true;
                     end
                end {6}
              else
                begin
                   DejaReussi [P,Q] := true;
                   DejaReussi [Q,P] := true;
                end
        end {5}
      else
        begin
           DejaReussi [P,Q] := true;
           DejaReussi [Q,P] := true;
        end
      end {4}
    end; {3}
  FaceCour := FaceCour + 1;
  end {2}
end; {1}

procedure VoirSiFaceComposeeAretesInvisibles(P:integer;var TestOK:boolean);
var NbreSt, I, St, NbreStInv: integer;
begin
   NbreSt := Face [P,0];
   I := 0;
   NbreStInv := 0;
   repeat
      I := I + 1;
      St := Face [P,I];
      if St > NbreStInitial then inc(NbreStInv)
   until I = NbreSt;
   if NbreSt = NbreStInv then TestOK := true else TestOK := false
end;

procedure EffaceAretesInvisibles (P: integer);
var I, St1, St2, NS : integer;

    procedure EffaceSegment (St1, St2: integer);
    begin
       Couleur (Noir);
       MoveTo (StEcran [St1,1], StEcran [St1,2]);
       LineTo (StEcran [St2,1], StEcran [St2,2]);
       Couleur (Blanc);
       PutPixel (StEcran [St1,1], StEcran [St1,2], Blanc);
       PutPixel (StEcran [St2,1], StEcran [St2,2], Blanc)
    end;

begin
   NS := Face [P,0];
   for I := 1 to NS - 1 do
   begin
      St1 := Face [P,I];
      St2 := Face [P,I+1];
      if (St1>NbreStInitial) and (St2>NbreStInitial) then EffaceSegment (St1,St2)
   end;
   St1 := Face [P,1];
   St2 := Face [P,NS];
   if St1 > NbreStInitial then  EffaceSegment (St1, St2)
end;

procedure TraceLesFacesRestantes;
var Poly        : array [1..LimAretes] of PointType;
    NbreSt      : integer;
    I, P, J, St : integer;
begin
   SetFillStyle (SolidFill, Noir);
   for I := 1 to NbreFacesVis do
   begin
      P := Prior [I];
      VoirSiFaceComposeeAretesInvisibles (P, TestOK);
      if not(TestOK)
      then begin
              NbreSt := Face [P,0];
              for J := 1 to NbreSt do
              begin
                 St := Face [P,J];
                 with Poly [J] do
                 begin
                    X := StEcran [St,1];
                    Y := StEcran [St,2]
                 end
              end;
              FillPoly (NbreSt, Poly);
              if AretesInvisibles [P] then EffaceAretesInvisibles (P);
              repeat until KeyPressed;    Touche := ReadKey
           end
   end
end;

BEGIN
   OuvertureFichierDonnees;
   LectureParametresDeVision;
   EcranGraphique;
   Cloture (0, MaxX, 0, MAxY);
   InitialisationDesTables;
   LectureSommetsEtFaces;
   BoucleDesTests;
   TraceLesFacesRestantes;
   Attente;
   EcranTexte
END.

