UNIT PLOT2D;

INTERFACE

uses Crt, printer, graph;

const Noir      = 0;
      Blanc     = 15;
      HautEcran = 347;

var  XgFen, XdFen, YbFen, YhFen     : real;
     XgClot, XdClot, YbClot, YhClot : real;
     XOrig, YOrig                   : real;
     A8, B8, A9, B9                 : real;
     Ferme, Ouvert                  : string;

type Table = array [1..500] of real;

procedure PlotterOn;
procedure Fenetre (F1, F2, F3, F4 : real);
procedure Cloture (C1, C2, C3, C4 : real);procedure Plume (Numero: byte);
procedure TraceVers (X, Y : real);
procedure DeplaceEn (X, Y : real);
procedure Bordure (Couleur: byte);
procedure TraceBordure;
procedure Axes;
procedure CorrectionAxeX (XOrig, XgFen, UnitX: real; var CorrectX: real);
procedure CorrectionAxeY (YOrig, YbFen, UnitY: real; var CorrectY: real);
procedure Gradue (UnitX, UnitY : real);
procedure Grille (UnitX, UnitY : real);
procedure Polygone (X, Y: table; Lim: integer; Mode: string; Couleur: byte);
procedure DessinePolygone (X, Y: table; Lim: integer; Mode: string);
procedure EffacePolygone (X, Y: Table; Lim: integer; Mode: string);
procedure TraceCercle (XC, YC, R: real; Couleur: byte; Pointille: boolean);
procedure Cercle (XC, YC, R:real; Couleur: byte);
procedure CerclePointille (XC, YC, R: real; Couleur: byte);
Procedure MessageAttente;
procedure Attente;
procedure Bip;
function Signe (N: real): real;
function Puissance (Base, Exposant : real): real;
function Factorielle (X: integer) : real;

IMPLEMENTATION

procedure PlotterOn;
var XP1, YP1, XP2, YP2 : integer;
begin
   XP1 := round (XgFen * A8 + B8);
   YP1 := round (YbFen * A9 + B9);
   XP2 := round (XdFen * A8 + B8);
   YP2 := round (YhFen * A9 + B9);
   writeln (lst, '^IW', XP1, ',', YP1, ',', XP2, ',', YP2)
end;

procedure Fenetre (F1, F2, F3, F4 : real);
begin
   XgFen := F1;
   XdFen := F2;
   YbFen := F3;
   YhFen := F4
end;

procedure Cloture (C1, C2, C3, C4 : real);
begin
   XgClot  := C1;
   XdClot  := C2;
   YbClot  := C3;
   YhClot  := C4;
   A8 := (XdClot - XgClot) / (XdFen - XgFen) * 100;
   B8 := (XgClot * XdFen - XdClot * XgFen) / (XdFen - XgFen) * 100;
   A9 := (YhClot - YbClot) / (YHFen - YBFen) * 100;
   B9 := (YbClot * YHFen - YhClot * YBFen) / (YHFen - YBFen) * 100;
   PlotterOn
end;

procedure Plume (Numero: byte);
begin
   writeln (lst, 'J', Numero)
end;

procedure TraceVers (X, Y : real);
var XEcran, YEcran : integer;
begin
   XEcran := round (X * A8 + B8);
   YEcran := round (Y * A9 + B9);
   writeln (lst, 'D',XEcran, ',', YEcran)
end;

procedure DeplaceEn (X, Y : real);
var XEcran, YEcran : integer;
begin
   XEcran := round (X * A8 + B8);
   YEcran := round (Y * A9 + B9);
   writeln (lst, 'M', XEcran, ',', YEcran)
end;

procedure Bordure (Couleur: byte);
begin
   DeplaceEn (Xgfen, YbFen);
   TraceVers (XdFen, YbFen);
   TraceVers (XdFen, YhFen);
   TraceVers (Xgfen, Yhfen);
   TraceVers (XgFen, Ybfen)
end;

procedure TraceBordure;
begin
   Bordure (Blanc)
end;

procedure Axes;

   procedure PointeFlecheSurX;
   const Val = 20;
   begin
      writeln (lst, 'R', -Val, ',', Val);
      writeln (lst, 'I', Val, ',', -Val);
      writeln (lst, 'I', -Val, ',', -Val)
   end;

   procedure PointeFlecheSurY;
   const Val = 20;
   begin
      writeln (lst, 'R', -Val, ',', -Val);
      writeln (lst, 'I', Val, ',', Val);
      writeln (lst, 'I', Val, ',', -Val)
   end;

begin
   XOrig := XgFen;
   YOrig := YbFen;
   if (XgFen < 0) and (XdFen > 0) then XOrig := 0;
   if (YbFen < 0) and (YhFen > 0) then YOrig := 0;
   DeplaceEn (XgFen, YOrig);
   TraceVers (XdFen, YOrig);
(*   PointeFlecheSurX;*)
   DeplaceEn (XOrig, YbFen);
   TraceVers (XOrig, YhFen);
(*   PointeFlecheSurY    *)
end;

procedure CorrectionAxeX (XOrig, XgFen, UnitX: real; var CorrectX: real);
var NbreTirets: real;
begin
   if XOrig <= 0
      then begin
              NbreTirets := (XOrig - XgFen) / UnitX;
              CorrectX   := (NbreTirets - int(NbreTirets)) * UnitX
           end
      else CorrectX := XgFen - trunc (XgFen)
end;

procedure CorrectionAxeY (YOrig, YbFen, UnitY: real; var CorrectY: real);
var NbreTirets: real;
begin
   if YOrig <= 0
      then begin
              NbreTirets := (YOrig - YbFen) / UnitY;
              CorrectY   := (NbreTirets - int(NbreTirets)) * UnitY
           end
      else CorrectY := YbFen - trunc (YbFen)
end;

procedure Gradue (UnitX, UnitY : real);
var CorrectX, CorrectY : real;
    TiretX, TiretY     : real;
    X, Y               : real;
    Tiret              : byte;
begin
   Tiret := 10;
   if UnitX > 0 then
      begin
         CorrectionAxeX (Xorig, XgFen, UnitX, CorrectX);                             X := XgFen + CorrectX;
         repeat
            DeplaceEn (X, YOrig);
            writeln (lst, 'R', 0, ',', -Tiret);
            writeln (lst, 'I', 0, ',', 2 * Tiret);
            X := X + UnitX
         until X > XdFen
      end;
   if UnitY > 0 then
      begin
         CorrectionAxeY (YOrig, YbFen, UnitY, CorrectY);
         Y := YbFen + CorrectY;
         repeat
            DeplaceEn (XOrig, Y);
            writeln (lst, 'R', -Tiret, ',', 0);
            writeln (lst, 'I', 2 * Tiret, ',', 0);
            Y := Y + UnitY
         until Y > YhFen
      end
end;

procedure Grille (UnitX, UnitY : real);
var  CorrectX, CorrectY : real;
     I, J               : real;
begin
   CorrectionAxeX (XOrig, XgFen, UnitX, CorrectX);
   CorrectionAxeY (YOrig, YbFen, UnitY, CorrectY);
   I := trunc(XgFen + CorrectX);
   while I <= trunc(XdFen) do
   begin
      J := trunc(YbFen + CorrectY);
      while J <= trunc(YhFen) do
      begin
         DeplaceEn (I, J);
         TraceVers (I, J);
         J := J + UnitY
      end;
      I := I + UnitX
   end
end;

procedure Polygone (X, Y: table; Lim: integer; Mode: string; Couleur: byte);
var I : integer;
begin
   DeplaceEn (X[1], Y[1]);
   for I := 2 to LIM do TraceVers (X[I], Y[I]);
   if Mode=Ferme then TraceVers (X[1], Y[1])
end;

procedure DessinePolygone (X, Y: table; Lim: integer; Mode: string);
begin
   Polygone (X, Y, Lim, Mode, Blanc)
end;

procedure EffacePolygone (X, Y: Table; Lim: integer; Mode: string);
begin
   Polygone (X, Y, Lim, Mode, Noir)
end;

procedure TraceCercle (XC, YC, R: real; Couleur: byte; Pointille: boolean);
var   S, C, X, Y, Aux : real;
      N               : integer;
begin
   S := sin(Pi / 24);
   C := cos(Pi / 24);
   X := XC + R;
   Y := YC;
   DeplaceEn (X, Y);
   for N := 2 to 49 do
      begin
         Aux := XC + (X - XC) * C - (Y - YC) * S;
         Y   := YC + (X - XC) * S + (Y - YC) * C;
         X   := Aux;
         if Pointille then DeplaceEn (X, Y);
         TraceVers (X, Y)
      end
end;

procedure Cercle (XC, YC, R:real; Couleur: byte);
var Pointille : boolean;
begin
   TraceCercle (XC, YC, R, Couleur, false)
end;

procedure CerclePointille (XC, YC, R: real; Couleur: byte);
var Pointille : boolean;
begin
   TraceCercle (XC, YC, R, Couleur, true)
end;

Procedure MessageAttente;
const  Esc = #27;
var    Ch       : char;
       ViewPort : ViewPortType;
       X1, Y1, X2, Y2 : integer;
begin
   gotoXY (1,23);
   writeln ('ESC pour arrter et RETURN pour continuer');
   sound(400);
   delay(100);
   nosound;
   repeat until KeyPressed;
   Ch := ReadKey;
   if Ch = Esc
      then
         begin
            Halt (0)
         end
end;

procedure Attente;
begin
   sound(400);
   delay(100);
   nosound;
   readln
end;

Procedure Bip;
begin
   sound(2000);
   delay(50);
   nosound
end;

function Signe (N: real): real;
begin
   if N >= 0 then Signe := 1 else Signe := -1
end;

function Puissance (Base, Exposant : real): real;
begin
   if abs(Base) < 1E-6
      then if Exposant = 0.0
              then Puissance := 1.0
              else Puissance := 0.0
      else if Base > 0
              then Puissance := exp (Exposant * ln (Base))
              else if odd(round(Exposant))
                      then Puissance := Signe(Base) * exp (Exposant * ln (abs(Base)))
                      else Puissance := -Signe(Base) * exp (Exposant * ln (abs(Base)))
end;

function Factorielle (X: integer) : real;
var I : integer;
    F : real;
begin
   if X < 1
      then Factorielle := 1
      else
         begin
            F := 1;
            for I := 2 to X do F := F * I;
            Factorielle := F
         end
end;


END.
