(* Deformation de figures sans trous - Placez la feuille A4 verticalement
   Le programme trace la vue de dpart, 13 dformations puis la vue d'arrive
   Vous pouvez facilement augmenter NbreDefor
*)

program DEFORM3;       

{$M $8000,$0,$A0000}

uses Crt, Printer, Plot2D;

const NbreDefor   = 13;
      NbreSommets = 43;

var  XA, YA, XD, YD, Code : Table;

procedure TracePolygone (XR, YR , Code: table);
var K : integer;
begin
   For K := 1 to NbreSommets do
   begin
      if Code[K] = 0
         then DeplaceEn (XR[K], YR[K])
         else TraceVers (XR[K], YR[K])
   end
end;

procedure LectureFigureDepart;
begin
   XD[1] := 95;      YD[1] := 85;      Code[1] := 0;
   XD[2] := 87.5;    YD[2] := 85;      Code[2] := 1;
   XD[3] := 82.5;    YD[3] := 87.5;    Code[3] := 1;
   XD[4] := 77.5;    YD[4] := 87.5;    Code[4] := 1;
   XD[5] := 70;      YD[5] := 80;      Code[5] := 1;

   XD[6] := 70;    YD[6] := 80;     Code[6] := 0;
   XD[7] := 50;    YD[7] := 65;     Code[7] := 1;
   XD[8] := 35;    YD[8] := 45;     Code[8] := 1;
   XD[9] := 20;    YD[9] := 30;     Code[9] := 1;
   XD[10] := 5;    YD[10] := 15;    Code[10] := 1;

   XD[11] := 5;    YD[11] := 15;     Code[11] := 0;
   XD[12] := 15;    YD[12] := 20;    Code[12] := 1;

   XD[13] := 15;    YD[13] := 20;    Code[13] := 0;
   XD[14] := 10;    YD[14] := 10;    Code[14] := 1;
   XD[15] := 30;    YD[15] := 25;    Code[15] := 1;

   XD[16] := 30;    YD[16] := 25;    Code[16] := 0;
   XD[17] := 25;    YD[17] := 15;    Code[17] := 1;
   XD[18] := 45;    YD[18] := 30;    Code[18] := 1;
   XD[19] := 60;    YD[19] := 40;    Code[19] := 1;

   XD[20] := 60;    YD[20] := 40;    Code[20] := 0;
   XD[21] := 70;    YD[21] := 50;    Code[21] := 1;
   XD[22] := 75;    YD[22] := 60;    Code[22] := 1;
   XD[23] := 75;    YD[23] := 65;    Code[23] := 1;
   XD[24] := 70;    YD[24] := 67.5;  Code[24] := 1;
   XD[25] := 60;    YD[25] := 65;    Code[25] := 1;
   XD[26] := 50;    YD[26] := 55;    Code[26] := 1;

   XD[27] := 50;    YD[27] := 55;    Code[27] := 0;
   XD[28] := 40;    YD[28] := 40;    Code[28] := 1;
   XD[29] := 30;    YD[29] := 25;    Code[29] := 1;

   XD[30] := 52.5;  YD[30] := 35;    Code[30] := 0;
   XD[31] := 60;    YD[31] := 35;    Code[31] := 1;

   XD[32] := 60;    YD[32] := 35;    Code[32]:= 0;
   XD[33] := 75;    YD[33] := 45;    Code[33]:= 1;
   XD[34] := 85;    YD[34] := 60;    Code[34]:= 1;
   XD[35] := 87.5;  YD[35] := 70;    Code[35] := 1;
   XD[36] := 90;    YD[36] := 80;    Code[36] := 1;
   XD[37] := 95;    YD[37] := 85;    Code[37] := 1;
   XD[38] := 85;    YD[38] := 80;    Code[38] := 1;

   XD[39] := 82.5;  YD[39] := 82.5;    Code[39] := 0;
   XD[40] := 80;    YD[40] := 82.5;    Code[40] := 1;
   XD[41] := 80;    YD[41] := 80;      Code[41] := 1;
   XD[42] := 82.5;  YD[42] := 80;      Code[42] := 1;
   XD[43] := 82.5;  YD[43] := 82.5;    Code[43] := 1;
end;

procedure LectureFigureArrivee;
begin
   XA[1] := 5;    YA[1] := 75;
   XA[2] := 5;    YA[2] := 90;
   XA[3] := 10;    YA[3] := 80;
   XA[4] := 15;    YA[4] := 90;
   XA[5] := 15;    YA[5] := 75;

   XA[6] := 20;    YA[6] := 80;
   XA[7] := 20;    YA[7] := 65;
   XA[8] := 30;    YA[8] := 65;
   XA[9] := 30;    YA[9] := 80;
   XA[10] :=20;    YA[10] := 80;

   XA[11] := 37.5;    YA[11] := 75;
   XA[12] := 37.5;    YA[12] := 75;

   XA[13] := 37.5;    YA[13] := 70;
   XA[14] := 37.5;    YA[14] := 65;
   XA[15] := 37.5;    YA[15] := 55;

   XA[16] := 45;    YA[16] := 45;
   XA[17] := 45;    YA[17] := 60;
   XA[18] := 55;    YA[18] := 45;
   XA[19] := 55;    YA[19] := 60;

   XA[20] := 70;    YA[20] := 50;
   XA[21] := 60;    YA[21] := 50;
   XA[22] := 60;    YA[22] := 42.5;
   XA[23] := 65;    YA[23] := 42.5;
   XA[24] := 60;    YA[24] := 42.5;
   XA[25] := 60;    YA[25] := 35;
   XA[26] := 70;    YA[26] := 35;

   XA[27] := 70;    YA[27] := 25;
   XA[28] := 75;    YA[28] := 40;
   XA[29] := 80;    YA[29] := 25;

   XA[30] := 78;    YA[30] := 30;
   XA[31] := 72;    YA[31] := 30;

   XA[32] := 85;    YA[32] := 30;
   XA[33] := 85;    YA[33] := 25;
   XA[34] := 85;    YA[34] := 15;
   XA[35] := 90;    YA[35] := 15;
   XA[36] := 95;    YA[36] := 15;
   XA[37] := 95;    YA[37] := 25;
   XA[38] := 95;    YA[38] := 30;

   XA[39] := 40;   YA[39] := 77.5;
   XA[40] := 35;    YA[40] := 77.5;
   XA[41] := 35;    YA[41] := 72.5;
   XA[42] := 40;    YA[42] := 72.5;
   XA[43] := 40;    YA[43] := 77.5;
end;

procedure Deformation;
var I, J   : integer;
    XR, YR : table;
begin
   for i := 0 to NbreDefor + 1 do
   begin
      case I of
         0 : Cloture (0, 4, 18, 22);
         1 : Cloture (4.75, 8.75, 18, 22);
         2 : Cloture (9.5, 13.5, 18, 22);
         3 : Cloture (0,4, 13.5,17.5);
         4 : Cloture (4.75,8.75,13.5,17.5);
         5 : Cloture (9.5,13.5,13.5,17.5);
         6 : Cloture (0,4, 9,13);
         7 : Cloture (4.75,8.75, 9,13);
         8 : Cloture (9.5,13.5, 9,13);
         9 : Cloture (0,4, 4.5,8.5);
        10 : Cloture (4.75,8.75, 4.5,8.5);
        11 : Cloture (9.5,13.5, 4.5,8.5);
        12 : Cloture (0, 4, 0,4);
        13 : Cloture (4.75, 8.75, 0,4);
        14 : Cloture (9.5,13.5, 0,4);
(*         0 : Cloture (0, 4, 20, 24);
         1 : Cloture (4, 8, 20, 24);
         2 : Cloture (8, 12, 20, 24);
         3 : Cloture (12, 16, 20, 24);
         4 : Cloture (0, 4, 16, 20);
         5 : Cloture (4, 8, 16, 20);
         6 : Cloture (8, 12, 16, 20);
         7 : Cloture (12, 16, 16, 20);
         8 : Cloture (0, 4, 12, 16);
         9 : Cloture (4, 8, 12, 16);
        10 : Cloture (8, 12, 12, 16);
        11 : Cloture (12, 16, 12, 16);
        12 : Cloture (0, 4, 8, 12);
        13 : Cloture (4, 8, 8, 12);
        14 : Cloture (8, 12, 8, 12);
        15 : Cloture (12, 16, 8, 12);
        16 : Cloture (0, 4, 4, 8);
        17 : Cloture (4, 8, 4, 8);
        18 : Cloture (8, 12, 4, 8);
        19 : Cloture (12, 16, 4, 8);
        20 : Cloture (0, 4, 0, 4);
        21 : Cloture (4, 8, 0, 4);
        22 : Cloture (8, 12, 0, 4);
        23 : Cloture (12, 16, 0, 4);
*)
      end;
      for J := 1 to NbreSommets + 1 do
      begin
         XR[J] := XD[J] + I * (XA[J] - XD[J]) / (NbreDefor + 1);
         YR[J] := YD[J] + I * (YA[J] - YD[J]) / (NbreDefor + 1)
      end;
      TraceBordure;
      TracePolygone (XR, YR, Code);
   end
end;

BEGIN
   Fenetre (0, 100, 0, 100);
   Plume (1);
   LectureFigureDepart;
(*
   Cloture (0,6.5,0,6.5);
   TraceBordure;
   Axes; Gradue (10,10);Grille (5,5);
   TracePolygone (XD,YD,Code);
*)
   LectureFigureArrivee;
(*
   Cloture (7,13.5,0,6.5);
   TraceBordure;
   Axes; Gradue (10,10);Grille (5,5);
   TracePolygone (XA, YA, Code);plume (0);halt;
*)
   LectureFigureArrivee;
   Deformation;
   Plume (0)
END.

