program Fractals;   (* Uniquement la courbe *)

Uses Crt, Printer, Plot2D;

const Limite = 4096;

var  XBase, YBase   : array [0..10] of real;
     Xgen, YGen     : array [0..20] of real;
     XFract, YFract : array [0..Limite] of real;
     Ordre          : byte;
     PointsBase     : byte;
     PointsGen      : byte;
     F1, F2, F3, F4 : real;
     C1, C2, C3, C4 : real;
     NomFic         : string;
     NomCourbe      : string;

function PuisEntier (Base, Exposant: integer) : word;
var I, Prod : word;
begin
   Prod := 1;
   for I := 1 to Exposant do Prod := Prod * Base;
   PuisEntier := Prod
end;

procedure LectureNomFichier;
var N         : byte;
    Fichier   : text;
begin
   clrscr;
   writeln (' ':20,'LES  COURBES  FRACTALES');
   writeln (' ':20,'=======================');
   gotoXY (20,6);
   clrscr;
   write ('Nom du fichier  lire (F pour FIN) : ');
   readln (Nomfic);
   if (NomFic <> 'F') and (NomFic <> 'f')
   then
      begin
         Nomfic := concat (Nomfic, '.TXT');
         assign (Fichier, NomFic);
         reset (Fichier);
         readln (Fichier, NomCourbe);
         readln (Fichier, NomFic);
         readln (Fichier, PointsBase);
         for N := 0 to PointsBase do
         begin
            readln (Fichier, XBase [N]);
            readln (Fichier, YBase [N])
         end;
         readln (Fichier, PointsGen);
         for N := 0 to PointsGen -1 do
         begin
            readln (Fichier, XGen [N]);
            readln (Fichier, YGen [N])
         end;
         readln (Fichier, F1);
         readln (Fichier, F2);
         readln (Fichier, F3);
         readln (Fichier, F4);
         close (Fichier)
      end
end;

procedure LectureOrdreCourbe;
begin
   clrscr;
   write ('Ordre de la courbe (0 pour terminer) : ');
   readln (Ordre);
   if Ordre <> 0 then begin
                         write ('Entrez la clture: ');
                         readln (C1, C2, C3, C4);
                      end
end;

procedure CalculCourbe (O, B, G: byte);
var I,Aux1,Aux2 : word;
    J,M1,M2,K   : word;
    X1,Y1       : real;
begin
   XFract [0] := 0;
   YFract [0] := 0;
   XFract [PuisEntier (G,O)] := 1;
   YFract [PuisEntier (G,O)] := 0;
   for I := 0 to O - 1 do
   begin
      Aux1 := PuisEntier (G,O - I);
      Aux2 := PuisEntier (G,O - I - 1);
      J := 0;
      repeat
         M1 := J + Aux1;
         X1 := XFract [M1] - XFract [J];
         Y1 := YFract [M1] - YFract [J];
         for K := 1 to G-1 do
         begin
            M2 := J + K * Aux2;
            XFract [M2] := X1 * XGen [K] - Y1 * YGen [K] + XFract [J];
            YFract [M2] := Y1 * XGen [K] + X1 * YGen [K] + YFract [J]
         end;
         J := J + Aux1
      until J > PuisEntier (G, O) - 1;
   end
end;

procedure DessineCourbe (O, B, G: byte);
var Diff1, Diff2 : real;
    M, N         : integer;
    XX, YY       : real;
    Chaine       : string;
begin
   Fenetre (F1, F2, F3, F4);
   Cloture (C1, C2, C3, C4);
   DeplaceEn (XBase [0], YBase [0]);
   for M := 0 to B-1 do
   begin
      Diff1 := XBase [M+1] - XBase [M];
      Diff2 := YBase [M+1] - YBase [M];
      for N := 0 to PuisEntier (G,O) do
      begin
         XX := Diff1 * XFract [N] - Diff2 * YFract [N] + XBase [M];
         YY := Diff2 * XFract [N] + Diff1 * YFract [N] + YBase [M];
         TraceVers (XX, YY)
      end
   end;
end;

function TestGrandeur: boolean;
begin
   if Ordre * ln(PointsGen - 1) > ln(Limite)
      then TestGrandeur := false
      else TestGrandeur := true
end;

BEGIN
   LectureNomFichier;
   while (NomFic <> 'F') and (NomFic <> 'f') do
   begin
      LectureOrdreCourbe;
      while (Ordre <> 0) and TestGrandeur do
      begin
         CalculCourbe (Ordre, PointsBase, PointsGen - 1);
         Plume (1);
         DessineCourbe (Ordre, PointsBase, PointsGen - 1);
         Plume (0);
         LectureOrdreCourbe
      end;
      if TestGrandeur
         then LectureNomFichier
         else
            begin
               writeln ('Dpassement de capacit des tables...');
               writeln ('Enfoncez ENTER pour continuer.');
               Attente
            end;
   end
END.

