(* Surfaces d'quations paramtriques - Equations du tore page 203
   Relire la signification de DE lors d'une projection parallle page 292
   Il n'est pas facile de trouver la bonne valeur de DE, gnralement
   quelques essais seront ncessaires. Pour les essais ne prenez pas des
   valeurs de dpart, d'arrive et de pas trop petites afin d'acclrer
   le trac. D'aprs le rsultat obtenu vous pourrez corriger facilement.
*)

program SurfPara;   

Uses Crt, Printer,Graph, Plot3D;

var U, UDebut, Ufin, dU  : real;
    V, VDebut, Vfin, dV  : real;
    C1, C2, C3, C4: real;

Function FX(U, V: real) : real;
begin
   FX := (6 + 3*cos(U)) * cos(V)
end;

Function FY(U, V: real) : real;
begin
   FY := (6 + 3*cos(U)) * sin(V)
end;

Function FZ(U, V: real) : real;
begin
   FZ := 3 * sin(V)
end;

procedure EntreeDesParametresDeVision;
var Proj : byte;
begin
   clrscr;
   writeln ('VISUALISATION DES SURFACES');
   writeln ('==========================');
   gotoXY (1,5);
   writeln ('Type de projection: 1. Perspective');
   write   ('                    2. Parallele           ');
   readln (Proj);
   gotoXY (1,10);
   if Proj = 1
      then begin
              Projection := Perspective;
              write ('Valeur de Rho            : ');
              readln (Rho);
              write ('Valeur de Distance Ecran : ');
              readln (DE)
           end
      else begin
              Projection := Parallele;
              Rho := 1E20;
              write ('Valeur de Distance Ecran : ');
              readln (DE)
           end;
   write ('Valeur de Theta          : ');
   readln (Theta);
   write ('Valeur de Phi            : ');
   readln (Phi);
   writeln;
   write ('Courbes en U: valeurs de dpart, d''arrive et pas: ');
   readln (UDebut, UFin, dU);
   writeln;
   write ('Courbes en V: valeurs de dpart, d''arrive et pas: ');
   readln (VDebut, VFin, dV);
   write ('Cloture: ');
   readln (C1, C2, C3, C4);
end;

procedure FamilleDesCourbesEnU;
var  X, Y, Z : real;
begin
   U := UDebut;
   while U <= UFin do
   begin
      V := VDebut;
      X := FX(U, V);
      Y := FY(U, V);
      Z := FZ(U, V);
      DeplaceEn(X, Y, Z);
      while V <= VFin do
      begin
         X := FX(U, V);
         Y := FY(U, V);
         Z := FZ(U, V);
         TraceVers (X, Y, Z);
         V := V + dV
      end;
      U := U + dU
   end
end;

procedure FamilleDesCourbesEnV;
var X, Y, Z : real;
begin
   V := VDebut;
   while V <= VFin do
   begin
      U := UDebut;
      X := FX(U, V);
      Y := FY(U, V);
      Z := FZ(U, V);
      DeplaceEn(X, Y, Z);
      while U <= UFin do
      begin
         X := FX(U, V);
         Y := FY(U, V);
         Z := FZ(U, V);
         TraceVers (X, Y, Z);
         U := U + dU
      end;
      V := V + dV
   end
end;

procedure Affichage;
var S1, S2, S3, S4, S5, S6, S7, S8, S9, S10 : string;
begin
   if Projection = Parallele then S1 := 'infini'
                             else str (Rho:4:1, S1);
   str (Theta:4:1, S2);   str (Phi:4:1, S3);   str (DE:4:1, S4);
   str (UDebut:5:2, S5);  str (UFin:5:2, S6);  str (dU:5:2, S7);
   str (VDebut:5:2, S8);  str (VFin:5:2, S9);  str (dV:5:2, S10);
   SetTextStyle (SmallFont, HorizDir, 5);
   OutTextXY (10,335,'Rho=' + S1 + '   Theta=' + S2 +
     '   Phi=' + S3 + '   Ecran=' + S4+
     '   U=[' + S5 + ',' + S6 + ']   V=[' + S8 + ',' + S9 + ']');
end;

BEGIN
   EntreeDesParametresDeVision;
   Plume (1);
   Cloture (C1, C2, C3, C4);
   InitialiseProjection;
   FamilleDesCourbesEnU;
   FamilleDesCourbesEnV;
   Plume (0);
END.
