program Transfos;              { Transformations gnrales du plan }

Uses Crt, Printer, Plot2D;

const Lim  = 10;
      Coef = 0.0174532925;    {Pi/180}

var Choix1, Choix2        : byte;
    X, Y, Xtr, Ytr        : table;
    A, B, C, D, M, N, Max : real;
    C1, C2, C3, C4        : real;

procedure InitialisationObjet;
var I : byte;
begin
   X[1]  := 5;    Y[1] := 7;
   X[2]  := 2;    Y[2] := 7;
   X[3]  := 2;    Y[3] := 2;
   X[4]  := 3;    Y[4] := 2;
   X[5]  := 3;    Y[5] := 4;
   X[6]  := 4;    Y[6] := 4;
   X[7]  := 4;    Y[7] := 5;
   X[8]  := 3;    Y[8] := 5;
   X[9]  := 3;    Y[9] := 6;
   X[10] := 5;   Y[10] := 6
end;

procedure AffichageMenu;
begin
   Choix1 := 0;
   Choix2 := 0;
   clrscr;
   writeln ('Les transformations du plan');
   writeln ('===========================');
   writeln;
   write ('Entrez la clture: ');
   readln (C1, C2, C3, C4);
      gotoXY(1,6);
      writeln (' 0. Terminer la session');
      writeln (' 1. Par rapport  l''origine');
      writeln (' 2. Par rapport  un point quelconque');
      gotoXY(1,10);
      write ('Quel est le N choisi : ');
      readln (Choix1);
   if Choix1<>0 then
   begin
      gotoXY(1,13);
      writeln (' 1. Rotation');
      writeln (' 2. Homothetie');
      writeln (' 3. Symetrie');
      writeln (' 4. Cisaillement');
      gotoXY(1,18);
      write ('Quel est le N choisi : ');
      readln (Choix2)
   end
end;

procedure RechercheFenetre;
var Aux1, Aux2     : real;
    F1, F2, F3, F4 : real;
    I              : byte;

    procedure Limites (X, Y: real);
    begin
       if X < F1 then F1 := X;
       if X > F2 then F2 := X;
       if Y < F3 then F3 := Y;
       if Y > F4 then F4 := Y
    end;

begin
   F1 := 1E20;  F2 := -1E20;  F3 := F1;  F4 := F2;
   for I := 1 to Lim do Limites (X[I], Y[I]);
   Aux1 := -M * A + N * C + M;
   Aux2 := -M * B - N * D + N;
   for I := 1 to Lim  do
      begin
         Xtr[I] := A * X[I] - C * Y[I] + Aux1;
         Ytr[I] := B * X[I] + D * Y[I] + Aux2;
         Limites (Xtr[I], Ytr[I])
      end;
   Max := abs(F1);
   if Max < abs(F2) then Max := abs(F2);
   if Max < abs(F3) then Max := abs(F3);
   if Max < abs(F4) then Max := abs(F4);
   Max := 1.1*Max
end;

procedure FigureInitiale;
begin
   Axes;
   Gradue (1, 1);
   DessinePolygone (X, Y, Lim, Ferme)
end;

procedure InitialisationMatrice;
var RotDeg, RotRad, RH : real;
    Ch                 : char;
begin
   case Choix1 of
      0    : exit;
      1    : begin M := 0; N := 0 end;
      2    : begin
               gotoXY (1,21);
               write ('Coordonnee [M,N] de ce point:');
               readln (M,N)
             end
   end;
   case Choix2 of
      1  : begin
              gotoXY(1,23);
              write ('Angle de rotation en degres:');
              readln (RotDeg);
              RotRad := RotDeg*Coef;
              A := cos(RotRad);
              B := sin(RotRad);
              C := B;
              D := A
           end;
      2  : begin
              gotoXY(1,23);
              write ('Rapport d''homothetie:');
              readln (RH);
              A := RH;
              D := RH;
              B := 0;
              C := 0
           end;
      3  : begin
             B := 0;
             C := 0;
             if Choix1=1
             then begin
                     gotoXY (1,23);
                     write ('Selon l''axe X, Y ou l''origine O (X/Y/O) :');
                     readln (Ch);
                     case UpCase(Ch) of
                       'X' : begin
                                A :=  1;
                                D := -1
                             end;
                       'Y' : begin
                                A := -1;
                                D :=  1
                             end;
                       'O' : begin
                                A := -1;
                                D := -1
                             end
                     end
                  end
             else begin
                     A := -1;
                     D := -1
                  end
           end;
      4  : begin
              A := 1;
              D := 1;
              gotoXY (1,23);
              write ('Valeur de B et C :');
              readln (B,C)
           end
   end
end;

procedure FigureTransformee;
const Val = 20;
var I: byte;
begin
   DessinePolygone (Xtr, Ytr, Lim, Ferme);
   if Choix1 = 2 then begin
                         DeplaceEn (M, N);
                         writeln (lst, 'R', -Val, ',', 0);
                         writeln (lst, 'I', 2*Val, ',', 0);
                         writeln (lst, 'R', -Val, ',', -Val);
                         writeln (lst, 'I', 0, ',', 2*Val)
                       end
end;

procedure AfficheMatrice;
var L : integer;
    Ch1, Ch2 : string;
begin
   Cloture (0, 200, 0, 347);
   for L := 1 to Lim do
      begin
         str (Xtr[L]:8:5, Ch1);
         str (Ytr[L]:8:5, Ch2);
      end
end;

BEGIN
   InitialisationObjet;
   Repeat
       AffichageMenu;
       if Choix1<>0 then
          begin
             InitialisationMatrice;
             RechercheFenetre;
             Plume (1);
             Fenetre (-Max, Max, -Max, Max);
             Cloture (C1, C2, C3, C4);
             TraceBordure;
             FigureInitiale;
             FigureTransformee;
             Plume (0)
          end;
   Until Choix1=0
 END.
