program POLYCON;     { Surfaces caches d'un polydre convexe }

Uses Crt, Graph, GRAPH3D;

const MaxSommet = 50;
      MaxFaces  = 30;
      MaxAretes = 10;
      IncAng    = 5;
      IncRho    = 1;
      IncEcran  = 20;

var St         : array [1..MaxSommet, 1..3] of real;
    Fc         : array [1..MaxFaces, 0..MaxAretes] of integer;
    O1, O2, O3 : real;
    NF         : integer;
    Pointille  : boolean;

procedure VueDeDepart;
begin
   Projection := Perspective;
   Rho := 15;   Theta      := 0;   Phi        := 0;
   DE  := 400;  Pointille  := true
end;

procedure LectureSommets;
begin
   St[1,1]  := 2;     St[1,2]  := 2.7;     St[1,3]  :=-2;
   St[2,1]  := 2;     St[2,2]  := 2.7;     St[2,3]  := 0;
   St[3,1]  := 2;     St[3,2]  :=-2.7;     St[3,3]  := 0;
   St[4,1]  := 2;     St[4,2]  :=-2.7;     St[4,3]  :=-2;
   St[5,1]  :=-2;     St[5,2]  :=-2.7;     St[5,3]  :=-2;
   St[6,1]  :=-2;     St[6,2]  := 2.7;     St[6,3]  :=-2;
   St[7,1]  :=-2;     St[7,2]  := 2.7;     St[7,3]  := 0;
   St[8,1]  := 0;     St[8,2]  := 1.7;     St[8,3]  := 2;
   St[9,1]  := 0;     St[9,2]  :=-1.7;     St[9,3]  := 2;
   St[10,1] :=-2;     St[10,2] :=-2.7;     St[10,3] := 0
end;

procedure LectureFaces;
begin
   NF:= 9;
   Fc[1,0]:=4;  Fc[1,1]:=1;  Fc[1,2]:=2;  Fc[1,3]:=3;  Fc[1,4]:=4;
   Fc[2,0]:=4;  Fc[2,1]:=1;  Fc[2,2]:=6;  Fc[2,3]:=7;  Fc[2,4]:=2;
   Fc[3,0]:=3;  Fc[3,1]:=2;  Fc[3,2]:=7;  Fc[3,3]:=8;
   Fc[4,0]:=4;  Fc[4,1]:=2;  Fc[4,2]:=8;  Fc[4,3]:=9;  Fc[4,4]:=3;
   Fc[5,0]:=4;  Fc[5,1]:=1;  Fc[5,2]:=4;  Fc[5,3]:=5;  Fc[5,4]:=6;
   Fc[6,0]:=4;  Fc[6,1]:=7;  Fc[6,2]:=10; Fc[6,3]:=9;  Fc[6,4]:=8;
   Fc[7,0]:=3;  Fc[7,1]:=3;  Fc[7,2]:=9;  Fc[7,3]:=10;
   Fc[8,0]:=4;  Fc[8,1]:=10; Fc[8,2]:=5;  Fc[8,3]:=4;  Fc[8,4]:=3;
   Fc[9,0]:=4;  Fc[9,1]:=5;  Fc[9,2]:=10; Fc[9,3]:=7;  Fc[9,4]:=6
end;

procedure VecteurVision (St1,St2,St3:integer;var V1,V2,V3:real);
begin
   V1:=O1-St[St1,1];  V2:=O2-St[St1,2];  V3:=O3-St[St1,3]
end;

procedure VecteurNormal (St1,St2,St3:integer;var N1,N2,N3:real);
var P1, P2, P3, Q1, Q2, Q3 :real;
begin
   P1 := St[St2,1] - St[St1,1];
   P2 := St[St2,2] - St[St1,2];
   P3 := St[St2,3] - St[St1,3];
   Q1 := St[St3,1] - St[St1,1];
   Q2 := St[St3,2] - St[St1,2];
   Q3 := St[St3,3] - St[St1,3];
   N1 := P2 * Q3 - Q2 * P3;
   N2 := P3 * Q1 - Q3 * P1;
   N3 := P1 * Q2 - Q1 * P2
end;

function ProduitScalaire (V1, V2, V3, N1, N2, N3: real): real;
begin
   ProduitScalaire := V1 * N1 + V2 * N2 + V3 * N3
end;

procedure DessineObjet;
var F, St1, St2, St3, NS, No :integer;
    V1 , V2, V3, N1, N2, N3  : real;
    X, Y, Z, X0, Y0, Z0      : real;

   procedure DessineFace;
   var S: integer;
   begin
      NS := Fc[F,0];
      for S := 1 to NS do
      begin
         No:=Fc[F,S]; X:=St[No,1]; Y:=St[No,2]; Z:=St[No,3];
         if S = 1 then begin
                          DeplaceEn (X, Y, Z);
                          X0 := X; Y0 := Y; Z0 := Z
                       end
                  else TraceVers (X, Y, Z)
      end;
      TraceVers (X0, Y0, Z0)
   end;

begin
   for F := 1 to NF do
   begin
      St1 := Fc[F,1];    St2 := Fc[F,2];     St3 := Fc[F,3];
      VecteurVision (St1, St2, St3, V1, V2, V3);
      VecteurNormal (St1, St2, St3, N1, N2, N3);
      if ProduitScalaire (V1, V2, V3, N1, N2, N3) > 0
      then begin
              SetLineStyle (SolidLn, 0, NormWidth);
              DessineFace
           end
      else if Pointille then begin
                               SetLineStyle (DottedLn,0,NormWidth);
                               DessineFace
                             end
   end
end;

procedure CoordonneeOeil;
begin
   InitialiseProjection;
   O1 := Rho * Aux7;   O2 := Rho * Aux8;   O3 := Rho * Aux2
end;

procedure Affichage;
var S1, S2, S3, S4, S5 : string;
begin
   Cloture (0, MaxX, 0, 15);   ClearViewPort;
   SetTextStyle (SmallFont, HorizDir, 5);
   str (Theta:3:1, S2);  str (Phi:3:1, S3);  str (DE:4:1, S4);
   if projection = Perspective
   then begin
           str (Rho:3:1, S1);
           OutTextXY (90, 1,'Projection Perspective: Rho='+S1+
                      '   Theta= '+S2+'   Phi='+S3+'  Ecran='+S4)
        end
   else OutTextXY (90, 1,'Projection Parallele: Rho=infini'+
                   '   Theta= '+S2+'   Phi='+S3+'  Ecran='+S4);
   Cloture (0, MaxX, 0, MaxY)
end;

procedure Commandes;
const RhoPara = 1E20;
var RhoPersp, DEPersp, DEPara: real;
    Ch : char;
begin
   VueDeDepart;
   DEPara := 30;
   CoordonneeOeil;
   DessineObjet;
   Affichage;
   repeat
     Ch := UpCase(ReadKey);
     if Ch = #0 then Ch := UpCAse(ReadKey);
     if ord(Ch) in [72, 80, 75, 77, 69, 65, 43, 45, 84, 67]
     then
       begin
         ClearDevice;
         case ord(Ch) of
          72 : Phi   := Phi + IncAng;      {flche haut}
          80 : Phi   := Phi - IncAng;      {flche bas}
          75 : Theta := Theta - IncAng;    {flche gauche}
          77 : Theta := Theta + IncAng;    {flche droite}
          69 : Rho   := Rho + IncRho;      {E pour s'loigner}
          65 : Rho   := Rho - IncRho;      {A pour s'approcher}
          43 : DE    := DE + IncEcran;     {+ augmenter dist.cran}
          45 : DE    := DE - IncEcran;     {- diminuer dist.cran}
          84 : Pointille := not(Pointille);{T Pointilles on non}
          67 : If Projection = Perspective {C changer de projection}
                    then begin
                            RhoPersp := Rho;
                            DEPersp  := DE;
                            Projection := Parallele;
                            Rho := RhoPara;
                            DE  := DEPara
                         end
                    else begin
                            DEPAra  := DE;
                            Projection := Perspective;
                            Rho := RhoPersp;
                            DE  := DEPersp
                         end
            end;
            CoordonneeOeil;
            DessineObjet;
            Affichage
         end
   until UpCase(Ch) = 'F';
   EcranTexte
end;

BEGIN
   EcranGraphique;
   Cloture (0, MaxX, 0, MaxY);
   LectureSommets;
   LectureFaces;
   VueDeDepart;
   Commandes;
END.
