program RACINES;      { Racines relles + extremum d'une quation }

uses Crt, Graph, Graph2D;

var F1, F2, F3, F4   : real;
    A, B, Pas        : real;
    Precision        : real;
    AncA, AncB, AncP : real;
    Texte            : string;
    CurG, CurD       : pointer;
    XCurG, YCurG     : integer;
    XCurD, YCurD     : integer;

function F (X: real): real;
begin
   F := X*X*X*X - 9*X*X*X - 2*X*X + 120*X - 130
end;

procedure CreationCurseurs;
var  Xg, Xd, Yb, Yh : integer;
     Taille : word;
begin
    Xg := 0;     Xd := 10;   Yb := 0;    Yh := 50;
    MoveTo (10,0); LineRel(-10,0); LineRel (0,50); LineRel (10,0);
    Taille := ImageSize (Xg, Yb, Xd, Yh);
    Getmem (CurG, Taille);
    GetImage (Xg, Yb, Xd, Yh, CurG^);
    PutImage (Xg, Yb, CurG^, XORPut);
    MoveTo (0,0); LineRel (10,0); LineRel (0, 50); LineRel (-10, 0);
    Taille := ImageSize (Xg, Yb, Xd, Yh);
    Getmem (CurD, Taille);
    GetImage (Xg, Yb, Xd, Yh, CurD^);
    PutImage (Xg, Yb, CurD^, XORPut);
    SetTextStyle (SmallFont, HorizDir, 6);
end;

procedure EffaceCurseurs;
begin
   PutImage (XCurG, YCurG, CurG^, XORput);
   PutImage (XCurD, YCurD, CurD^, XORput)
end;

procedure LectureDonnees;
begin
   ClrScr;
   write ('Entrez l''intervalle d''tude [A,B] : ');
   readln (A, B);
   write ('Entrez le pas d''incrmentation    : ');
   readln (Pas);
   write ('Entrez la prcision souhaite     : ');
   readln (Precision);
   AncA := A;
   AncB := B;
   AncP := Pas
end;

procedure ChercheFenetre;
var Max, X, Y : real;
begin
   Max := 0;
   X := A;
   while X <= B do
   begin
      Y := F(X);
      if abs(Y) > Max then Max := abs(Y);
      X := X + Pas
   end;
   F1 := A;    F2 := B;   F3 := -Max;   F4 := Max
end;

procedure DessineFonction;
var X, Y: real;
begin
   Axes;
   Gradue (1,0);
   X := A;
   Y := F(A);
   DeplaceEn (X,Y);
   while X <= B do
   begin
      Y := F(X);
      TraceVers (X, Y);
      X := X + Pas
   end
end;

procedure Affiche (Texte: string);
begin
   Cloture (0, MaxX, 0, 20);
   ClearViewPort;
   OutTextXY(100, 1, Texte);
   Bip
end;

procedure MessagePrincipal;
var Ch : string;
begin
   Ch := ('Que voulez-vous faire : S/D/Z/E/R/T ? ');
   Affiche (Ch)
end;

procedure AfficheSolution (Txt: string; Val: real);
var Ch : string;
begin
   str (Val:8:5, Ch);
   Ch := concat (Txt,' = ', Ch, '        ', 'Enfoncez RETURN');
   Affiche (Ch);
   Attente;
   EffaceCurseurs
end;

procedure PlaceCurseur (var Cur: pointer; var XPos: real);
const PasX = 10;
      PasY = 10;
var   X, Y : integer;
      Ch   : char;
begin
   X := 350;Y := -190;PutImage (X, Y, Cur^, XORPut);MoveTo (X, Y);
   repeat
      Ch := ReadKey;
      if Ch = #0 then
      begin
         Ch := ReadKey;
         case Ch of
            #72 : begin    (* flche vers le haut *)
                     PutImage (X, Y, Cur^, XORput);
                     Y := Y - PasY;
                     PutImage (X, Y, Cur^, XORput)
                  end;
            #75 : begin    (* flche vers la gauche *)
                     PutImage (X, Y, Cur^, XORput);
                     X := X - PasX;
                     PutImage (X, Y, Cur^, XORput)
                  end;
            #77 : begin    (* flche vers la droite *)
                     PutImage (X, Y, Cur^, XORput);
                     X := X + PasX;
                     PutImage (X, Y, Cur^, XORput)
                  end;
            #80 : begin    (* flche vers le bas *)
                     PutImage (X, Y, Cur^, XORput);
                     Y := Y + PasY;
                     PutImage (X, Y, Cur^, XORput)
                  end
         end;
         MoveTo (X, Y)
      end;
   until Ch = chr(13);
   XPos := GetX / XRapport + XgFen
end;

procedure RacineSimple;
var R1, R2, Y1, Y2   : real;
    Milieu, YM, Prod : real;
begin
   Texte := 'Racine simple';
   PlaceCurseur (CurG, R1);   XCurG := GetX;    YCurG := GetY;
   PlaceCurseur (CurD, R2);   XCurD := GetX;    YCurD := GetY;
   Y1   := F(R1);
   Y2   := F(R2);
   Prod := Y1 * Y2;
   if Prod < 0
   then begin
           repeat
              Milieu := (R1 + R2) / 2;
              YM := F(Milieu);
              if YM <> 0
              then begin
                      if Y1 * YM > 0 then begin
                                             R1 := Milieu;
                                             Y1 := YM
                                          end
                                     else begin
                                             R2 := Milieu;
                                             Y2 := YM
                                          end
                   end
           until abs(R2 - R1) < Precision;
           AfficheSolution (Texte, Milieu)
        end
   else if Prod = 0
           then if Y1 = 0 then AfficheSolution (Texte, R1)
                          else AfficheSolution (Texte, R2)
           else
              begin
                 Affiche('Pas de racine dans [A,B]-Enfoncez RETURN');
                 Attente;
                 EffaceCurseurs
              end;
   MessagePrincipal
end;

procedure RechercheExtremum (var R1, R2: real; var Rac: real);
var X1, X2, Y1, Y2, Delta, Milieu, YM: real;
begin
   Y1 := F(R1);
   Y2 := F(R1 + 0.01);
   if Y1 < Y2
   then begin
           Delta := R2 - R1;
           while Delta >= 1E-8 do
           begin
              X1 := R1 + Delta / 3;      Y1 := F(X1);
              X2 := R2 - Delta / 3;      Y2 := F(X2);
              if Y1 < Y2 then R1 := X1 else R2 := X2;
              Delta := R2 - R1
           end
        end
   else if Y1 > Y2 then begin
                           Delta := R2 - R1;
                           while Delta >= 1E-8 do
                           begin
                              X1 := R1 + Delta / 3;      Y1 := F(X1);
                              X2 := R2 - Delta / 3;      Y2 := F(X2);
                              if Y1 < Y2 then R2 := X2 else R1 := X1;
                              Delta := R2 - R1
                           end
                        end;
   Rac  := (R1 + R2) / 2
end;

procedure RacineDouble;
var R1, R2, Y1, Y2 : real;
    Rac            : real;
begin
   PlaceCurseur (CurG, R1);   XCurG := GetX;    YCurG := GetY;
   PlaceCurseur (CurD, R2);   XCurD := GetX;    YCurD := GetY;
   RechercheExtremum (R1, R2, Rac);
   AfficheSolution ('Racine double', Rac);
   MessagePrincipal
end;

procedure Extremum;
var R1, R2, Y1, Y2 : real;
    Rac, YRac      : real;
begin
   PlaceCurseur (CurG, R1);   XCurG := GetX;    YCurG := GetY;
   PlaceCurseur (CurD, R2);   XCurD := GetX;    YCurD := GetY;
   RechercheExtremum (R1, R2, Rac);
   YRac := F(Rac);
   str (YRac:8:5, Texte);
   Texte := concat('Extremum = ', Texte, ' en X');
   AfficheSolution (Texte, Rac);
   MessagePrincipal
end;

procedure Questions; forward;

procedure Zoom;
var R1, R2       : real;
begin
   PlaceCurseur (CurG, R1);   XCurG := GetX;    YCurG := GetY;
   PlaceCurseur (CurD, R2);   XCurD := GetX;    YCurD := GetY;
   EffaceCurseurs;
   A := R1;
   B := R2;
   Pas := (R2 - R1) / 50;
   ChercheFenetre;
   EffaceEcran;
   Fenetre (F1, F2, F3, F4);
   Cloture (0, MaxX, 20, MaxY);
   DessineFonction;
   Questions
end;

procedure Redessine;
begin
   A   := AncA;
   B   := AncB;
   Pas := AncP;
   ChercheFenetre;
   Fenetre (F1, F2, F3, F4);
   Cloture (0, MaxX, 20, MaxY);
   EffaceEcran;
   DessineFonction;
   Questions
end;

procedure Termine;
begin
   Ecrantexte;
   writeln ('Termin ...');
   halt
end;

procedure Questions;
var Choix : char;
begin
   MessagePrincipal;
   repeat
      Choix := UpCase(ReadKey);
      Case Choix of
        'S': RacineSimple;
        'D': RacineDouble;
        'E': Extremum;
        'Z': Zoom;
        'R': Redessine;
        'T': Termine
      end
   until Choix = 'T'
end;

BEGIN
   LectureDonnees;
   ChercheFenetre;
   EcranGraphique;
   CreationCurseurs;
   Fenetre (F1, F2, F3, F4);
   Cloture (0, MaxX, 20, MaxY);
   DessineFonction;
   Questions;
   EcranTexte
END.
