program REBONDS;           { La balle qui rebondit }

Uses Crt, Graph, Graph2D;

Const Haut = 12;
      G    = 9.81;
      Pas  = 0.005;

var  Amort, VX, VY, V0, A, B, C    : real;
     X1, X2, XS, YS, Angle, Portee : real;
     Bonds, NbreRebonds            : byte;

procedure EntreeDesDonnees;
begin
   clrscr;
   writeln ('LA BALLE QUI REBONDIT');
   writeln ('=====================');
   gotoxy(1, 5);
   writeln ('______________________o  -  -  -  -  -  - > V');
   writeln ('                      ');
   writeln ('                      ');
   writeln ('                      ');
   writeln ('                   H  ');
   writeln ('                      ');
   writeln ('                      ');
   writeln ('                      ');
   gotoxy(1, 17);
   write ('Entrez la vitesse initiale  V . . . . : ');
   readln (VX);
   gotoxy(1, 19);
   write ('Entrez le coefficient d''amortissement : ');
   readln (Amort);
   gotoxy(1, 21);
   write ('Entrez le nombre de rebonds . . . . . : ');
   readln (NbreRebonds)
end;

procedure ParametresDepart;
begin
   Bonds := 0;
   X1    := 0;
   VY    := sqrt(2 * G * Haut);
   V0    := sqrt(sqr(VX) + sqr(VY));
   Angle := ArcTan (VY / VX);
   X2    := VX * VY / G;
   A     := -Haut / sqr(X2);
   B     := 0;
   C     := Haut
end;

procedure TraceParabole (Pt1, Pt2: real);
var X, Y : real;
begin
   X := Pt1;
   DeplaceEn (X, 0);
   while X < Pt2 do
   begin
      Y := A * sqr(X) + B * X + C;
      TraceVers (X, Y);
      X := X + Pas
   end;
   Bip;
   inc (Bonds)
end;

procedure CoefficientsParabole;
var DetPrinc, DetA, DetB, DetC, Portee : real;
begin
   YS       := sqr(V0 * sin(Angle)) / (2 * G);
   VY       := sqrt(2 * G * YS);
   Portee   := 2 * VX * VY / G;
   X2       := X1 + Portee;
   XS       := (X1 + X2) / 2;
   DetPrinc := sqr(X1)*(XS-X2)+sqr(X2)*(X1-XS)+sqr(XS)*(X2-X1);
   DetA     := YS * (X2 - X1);
   A        := DetA / DetPrinc;
   DetB     := YS * (sqr(X1) - sqr(X2));
   B        := DetB / DetPrinc;
   DetC     := YS * X1 * X2 * (X2 - X1);
   C        := DetC / DetPrinc
end;

procedure ImprimeResultats;
var S1, S2, S3, S4, Ch: string;
begin
   settextstyle (defaultfont,horizdir,1);
   str (Haut:3, S1);
   str (VX:4:1, S2);
   str (X2:5:2, S3);
   str (Amort:4:2, S4);
   Ch := concat ('Hauteur=',S1,'   Vitesse=',S2, '   Portee totale=',S3,
                 '   Amortissement=',S4);
   OutTextXY (50, 340, Ch)
end;


BEGIN
   EntreeDesDonnees;
   ParametresDepart;
   EcranGraphique;
   Fenetre (-0.5, 20, -0.5, Haut);
   Cloture (10, 719, 0, 347);
   Axes;
   Gradue (1, 1);
   TraceParabole (X1, X2);
   X1 := X2;
   repeat
      V0 := V0 * Amort;
      CoefficientsParabole;
      TraceParabole (X1, X2);
      X1 := X2;
   until Bonds = NbreRebonds;
   ImprimeResultats;
   Attente;
   EcranTexte
END.
