(*    Le clbre problme des 8 reines sur l'chiquier   *)

program ReineGra;

uses Crt, Graph, Graph2D;

var R            : array [1..8] of byte;
    XR, YR       : array [1..8] of integer;
    Ri           : array [1..8] of pointer;
    I, J, Ordre  : byte;
    TestOK, Fin  : boolean;
    X, Y, K, L   : integer;

const PasY    = 38;
      DepartY = 310;
      Duree   = 100;

procedure LectureOrdre;
begin
   ClrScr;
   repeat
      write ('Entrez l''ordre de l''chiquier (0 < Ordre < 9) : ');
      readln (Ordre)
   until (Ordre > 0) and (Ordre < 9)
end;

procedure Initialisation;
begin
   fillchar (R, sizeof(R), 0);
   XR[1] := 0;
   for I := 2 to Ordre do XR[I] := XR[I - 1] + 50;
   for I := 1 to Ordre do YR[I] := DepartY;
   L := 1 + (8 - Ordre) * 38;
   K := -1
end;

procedure CreeImageReine;
begin
   moverel (10,30);linerel (30,0);linerel (0,-3);linerel (-30,0);
   linerel (0,3);moverel (5,-5);linerel (0,2);linerel (20,0);
   linerel (0,-2);linerel (-20,0);linerel (-5,-5);linerel (-5,-8);
   moverel (2,-1);linerel (3,4);linerel (5,-2);linerel (0,-4);
   moverel (1,0);linerel (1,3);linerel (6,-2);linerel (1,-3);
   moverel (2,0);linerel (1,3);linerel (6,2);linerel (1,-3);
   moverel (1,0);linerel (0,4);linerel (5,2);linerel (3,-4);
   moverel (2,1);linerel (-5,8);linerel (-5,5);circle (5,10,2);
   circle (15,7,2);circle (25,5,2);circle (35,7,2);
   circle (45,10,2);FloodFill (25, 20, Blanc)
end;

procedure LireImage;
var Xg, Xd, Yb, Yh, Size : word;
begin
   Xg := 0;
   Xd := 50;
   Yb := 0;
   Yh := 37;
   Size := ImageSize (Xg, Yb, Xd, Yh);
   for I := 1 to Ordre do
   begin
      GetMem (Ri[I], Size);
      GetImage (Xg, Yb, Xd, Yh, Ri[I]^);
   end;
   PutImage (Xg, Yb, Ri[I]^, XORput)
end;

procedure TraceEchiquier;
var I : byte;
begin
   for I := 0 to Ordre do
   begin
      MoveTo (0, 310 - I * 38);
      LineTo (Ordre * 50, 310 - I * 38)
   end;
   for I := 0 to Ordre do
   begin
      MoveTo (I * 50, 310);
      LineTo (I * 50, 310 - Ordre * 38)
   end
end;

procedure PlaceLesReines;
begin
   Y := DepartY;
   for I := 1 to Ordre do
   begin
      X := XR[I];
      PutImage (X, Y, Ri[I]^, XORput)
   end;
   delay (Duree)
end;

procedure TestReinesPrecedentes;
begin
   TestOK := true;
   J    := 1;
   while (J <= I - 1) and (TestOK = true) do
   begin
      if (R[I]=R[J]) or (abs(R[I]-R[J])=I-J) then TestOK:=false;
      J := J + 1
   end
end;

procedure AvanceReine;
var D : integer;
begin
   R[I] := R[I] +1;
   X    := XR[I];
   Y    := YR[I];
   PutImage (X, Y, Ri[I]^, XORput);
{Otez les remarques des 9 lignes suivantes pour que les reines glissent}
(*   D := Y;
   repeat
      PutImage (X, D, Ri[I]^, XORput);
      delay (50);
      PutImage (X, D, Ri[I]^, XORput);
      D := D - 2
   until D <= YR[I] - PasY;
   YR[I] := YR[I] - PasY;
   Y := YR[I];*)
(*.... et placez-les autour des 2 lignes qui suivent ....*)
   YR[I] := YR[I] - PasY;
   Y := YR[I];
   PutImage (X, Y, Ri[I]^, XORput);
   delay (Duree)
end;

procedure DescenteColonne;
begin
   R[I] := 0;
   X    := XR[I];
   Y    := YR[I];
   PutImage (X, Y, Ri[I]^, XORput);
   X     := XR[I];
   YR[I] := DepartY;
   Y     := DepartY;
   PutImage (X, Y, Ri[I]^,XORput);
   I := I - 1;
   if I = 0 then Fin := true
            else I := I - 1;
   delay (Duree)
end;

procedure AffichageSolution;
var Ch, Chaine : string;
    C          : byte;
begin
   Chaine := '';
   for J := 1 to Ordre do
   begin
      str(R[J], Ch);
      Chaine := concat(Chaine, Ch)
   end;
   K := K + 1;
   C := K mod 4;
   case (K mod 4) of
      0 : OutTextXY (C * 77 + 412, L, Chaine);
      1 : OutTextXY (C * 77 + 412, L, Chaine);
      2 : OutTextXY (C * 77 + 412, L, Chaine);
      3 : begin
             OutTextXY (C * 77 + 412, L, Chaine);
             L := L + 15
          end
   end;
   delay (Duree*10);
end;

procedure ChercheLesSolutions;
begin
   Fin := false;
   I   := 0;
   while not(Fin) do
   begin
      I := I + 1;
      while (I <= Ordre) and not(Fin) do
      begin
         TestOK := false;
         while (R[I] < Ordre) and (TestOK = false) do
         begin
            AvanceReine;
            TestReinesPrecedentes;
         end;
         if not (TestOK) then DescenteColonne;
         I := I + 1
      end;
      if not(Fin) then
      begin
         AffichageSolution;
         I := Ordre;
         DescenteColonne;
         I := Ordre - 2
      end
   end
end;

BEGIN
   LectureOrdre;
   EcranGraphique;
   Initialisation;
   CreeImageReine;
   LireImage;
   TraceEchiquier;
   PlaceLesReines;
   ChercheLesSolutions;
   Attente;
   EcranTexte
END.

