program RK;   {Courbes integrales par Runge-Kutta avec curseur}

Uses Crt, Graph, Graph2D;

var F1, F2, F3, F4    : real;
    C1, C2, C3, C4, H : real;
    Cur               : pointer;
    XCur, YCur        : integer;

function F (X, Y : real) : real;
begin
   F := X + Y
end;

function G (X, Y : real) : real;
begin
   G := X * Y
end;

procedure EntreeDesDonnees;
begin
   ClrScr;
   writeln ('COURBES INTEGRALES PAR LA METHODE DE RUNGE-KUTTA');
   writeln ('================================================');
   gotoxy (1, 10);
   write ('Entrez la fenetre  [F1,F2,F3,F4] : ');
   readln (F1,F2,F3,F4);
   write ('Entrez le pas du trace           : ');
   readln (H)
end;

procedure CreationCurseur;
var  Xg, Xd, Yb, Yh : integer;
     Taille         : word;
begin
   Xg := 0;     Xd := 10;   Yb := 0;    Yh := 10;
   MoveRel (5,0);     LineRel(-5,0);      LineRel (0,5);
   MoveRel (10, 5);   LineRel (-10,-10);
   Taille := ImageSize (Xg, Yb, Xd, Yh);
   Getmem (Cur, Taille);
   GetImage (Xg, Yb, Xd, Yh, Cur^);
   PutImage (Xg, Yb, Cur^, XORPut)
end;

procedure RungeKutta (Y0, Z0: real);
const NbreSeg = 300;
var  Y, Z, Y1, Z1   : real;
     Seg, Aig       : integer;
     PointCrit      : real;
     Fin            : boolean;
     K1, K2, K3, K4 : real;
     L1, L2, L3, L4 : real;

begin
   Aig := 1;
   repeat
      Y := Y0;
      Z := Z0;
      DeplaceEn (Y, Z);
      Y1  := Y;
      Z1  := Z;
      Seg := 0;
      repeat
         TraceVers (Y1, Z1);
         Seg := Seg + 1;

         Y := Y1;
         Z := Z1;
         K1 := Aig * H * F(Y, Z);
         L1 := Aig * H * G(Y, Z);

         Y := Y1 + K1 / 2;
         Z := Z1 + L1 / 2;
         K2 := Aig * H * F(Y, Z);
         L2 := Aig * H * G(Y, Z);

         Y := Y1 + K2 / 2;
         Z := Z1 + L2 / 2;
         K3 := Aig * H * F(Y, Z);
         L3 := Aig * H * G(Y, Z);

         Y := Y1 + K3 / 2;
         Z := Z1 + L3 / 2;
         K4 := Aig * H * F(Y, Z);
         L4 := Aig * H * G(Y, Z);

         Y1 := Y + Aig * H / 6 * (K1 + 2 * K2 + 2 * K3 + K4);
         Z1 := Z + Aig * H / 6 * (L1 + 2 * L2 + 2 * L3 + L4);

         PointCrit := sqrt(sqr(F(Y, Z)) + sqr(G(Y, Z)));
         Y1 := Y + Aig * H * F(Y, Z);
         Z1 := Z + Aig * H * G(Y, Z)
      Until (Y1 < F1) or (Y1 > F2) or (Z1 < F3) or (Z1 > F4)
                      or (Seg > NbreSeg) or (PointCrit < 1E-3);
      Aig := -Aig
   Until Aig = 1
end;

procedure PlaceCurseur;
const PasX = 5;
      PasY = 5;
var   X, Y       : integer;
      Ch         : char;
      XPos, YPos : real;
begin
   X:=220; Y:=165; PutImage (X,Y,Cur^,XORPut); MoveTo (X,Y);
   repeat
      Ch := ReadKey;
      if Ch = #0
      then begin
              Ch := ReadKey;
              case Ch of
                #72 : begin    (* flche vers le haut *)
                         PutImage (X, Y, Cur^, XORput);
                         Y := Y - PasY;
                         PutImage (X, Y, Cur^, XORput)
                      end;
                #75 : begin    (* flche vers la gauche *)
                         PutImage (X, Y, Cur^, XORput);
                         X := X - PasX;
                         PutImage (X, Y, Cur^, XORput)
                      end;
                #77 : begin    (* flche vers la droite *)
                         PutImage (X, Y, Cur^, XORput);
                         X := X + PasX;
                         PutImage (X, Y, Cur^, XORput)
                      end;
                #80 : begin    (* flche vers le bas *)
                         PutImage (X, Y, Cur^, XORput);
                         Y := Y + PasY;
                         PutImage (X, Y, Cur^, XORput)
                      end
              end;
              MoveTo (X, Y)
           end
      else if UpCase (Ch) = 'D'
              then begin
                      XPos :=  GetX / XRapport + XgFen;
                      YPos := -GetY / YRapport + YhFen;
                      PutImage (X, Y, Cur^, XORput);
                      RungeKutta (XPos, YPos);
                      PutImage (X, Y, Cur^, XORput)
                   end
   until UpCase(Ch) = chr(27)
end;

procedure InitGraphisme;
begin
   EcranGraphique;
   CreationCurseur;
   Fenetre (F1, F2, F3, F4);
   Cloture (140, 580, 15, 345);
   TraceBordure;
   Axes;
   Gradue (1, 1);
end;


BEGIN
   EntreeDesDonnees;
   InitGraphisme;
   PlaceCurseur;
   EcranTexte
END.
