program Statist;

Uses Crt, Graph, GRAPH2D;

var Borne, Rep     : array[1..50] of real;
    F1, F2, F3, F4 : real;
    UX , UY        : real;
    NbreClasse     : integer;
    Effectif       : integer;
    Moyenne        : real;
    Variance       : real;
    EcartType      : real;

procedure LectureDonnees;
var R, I       : integer;
    B, Etendue : real;
begin
   clrscr;
   writeln ('ANALYSE STATISTIQUE');
   writeln ('===================');
   writeln;
   F1 := 1E20;
   F2 := -1E20;
   F3 := 0;
   F4 := -1E20;
   Effectif := 0;
   write ('Combien y a-t-il de classes: ');
   readln (NbreClasse);
   for I := 1 to NbreClasse do
   begin
      write ('Borne infrieure de la classe',I:3,': ');
      readln (B);
      write ('Quel est sa rptition : ');
      readln (R);
      Borne[I] := B;
      Rep[I]   := R;
      Effectif := Effectif + R;
      if R  > F4 then F4 := R
   end;
   writeln;
   write ('Borne suprieure de la classe',NbreClasse:3,': ');
   readln (Borne[NbreClasse+1]);
   Etendue := Borne[NbreClasse+1] - Borne[1];
   F1 := Borne[1] - 0.1 * Etendue;
   F2 := Borne[NbreClasse+1] + 0.1 * Etendue;
   Etendue := F4 - F3;
   F3 := F3 - 0.01 * Etendue;
   F4 := F4 + 0.01 * Etendue;
   writeln;
   write ('Quelle est l''unit sur l''axe X: ');
   readln (UX);
   write ('Quelle est l''unit sur l''axe Y: ');
   readln (UY)
end;

procedure Calculs;
var I: integer;
    Xi, RiXi, RiXi2: real;
begin
   RiXi := 0;
   RiXi2 := 0;
   for I := 1 to NbreClasse do
   begin
      Xi := (Borne[I] + Borne[I+1])/2;
      RiXi := RiXi + Rep[I] * Xi;
      RiXi2 := RiXi2 + Rep[I] * sqr(Xi)
   end;
   Moyenne  := RiXi / Effectif;
   Variance := RiXi2/Effectif - sqr(Moyenne);
   EcartType := sqrt(Variance)
end;

procedure Histogramme;
var I : integer;
begin
   Axes;
   Gradue (UX, UY);
   for I := 1 to NbreClasse do
       begin
          DeplaceEn (Borne[I], F3);
          TraceVers (Borne[I], Rep[I]);
          TraceVers (Borne[I+1], Rep[I]);
          TraceVers (Borne[I+1], F3)
       end
end;

procedure AffichageResultats;
var S: string;
begin
   PleineCloture;
   str (UX:6:2, S);
   S := concat ('Unite sur X =',S);
   OutTextXY (510, 10, S);
   str (UY:6:2, S);
   S := concat ('Unite sur Y =',S);
   OutTextXY (510, 40, S);
   str (Borne[1]:6:2, S);
   S := concat ('Borne gauche =',S);
   OutTextXY (510, 70, S);
   str (Effectif:5, S);
   S := concat ('Effectif =', S);
   OutTextXY (510, 100, S);
   str (Moyenne:10:3, S);
   S := concat ('Moyenne =', S);
   OutTextXY (510, 130, S);
   str (Variance:10:3, S);
   S := concat ('Variance =', S);
   OutTextXY (510,160, S);
   str (EcartType:10:3, S);
   S := concat ('Ecart-type =', S);
   OutTextXY (510, 190, S);
end;

BEGIN
   LectureDonnees;
   Calculs;
   EcranGraphique;
   Fenetre (F1, F2, F3, F4);
   Cloture (0, 500, 0, 330);
   Histogramme;
   AffichageResultats;
   Attente;
   EcranTexte
END.


