program SURFACES;

Uses Crt, Graph, GRAPH3D;

const LimX = 640;  { Dimensions de la carte HERCULES }
      LimY = 480;  { avec place pour une ligne de texte }

type Table = array [0..LimX] of integer;

var HMax, HMin, TabAux      : Table;
    X1, X2, Y1, Y2          : real;
    IncX, IncY              : real;
    F1, F2, F3, F4          : real;
    C1, C2, C3, C4          : integer;
    EchX, EchY, Ech         : real;
    Xg, Yg, Xd, Yd          : integer;
    NbreLignes , NbrePoints : integer;
    Vue                     : char;

function F(X, Y : real) : real;
begin
   F := 10*sin(X)/X*sin(Y)/Y
end;

function Signe (X: real): integer;
begin
   if X > 0 then Signe := 1
            else if X < 0 then Signe := -1 else Signe := 0
end;

Procedure EntreeDesParametresDeVision;
var Choix : byte;
begin
   ClrScr;
   writeln ('SURFACES D''EQUATIONS  Z=F(X,Y)');
   writeln ('==============================');writeln;
   write ('Quel est l''intervalle [X1,X2] : ');readln (X1,X2);
   write ('Quel est l''intervalle [Y1,Y2] : ');readln (Y1,Y2);
   write ('Nombre de lignes dsires     : ');readln (NbreLignes);
   write ('Nombre de points par lignes   : ');readln (NbrePoints);
   write ('Vue relle ou uniforme (R/U)  : ');readln (Vue);
   writeln;
   writeln ('Choix des projections');
   writeln ('---------------------');
   writeln ('1. Projection en vraie perspective');
   writeln ('2. Projection parallle quelconque');
   writeln ('3. Projection parallle dimtrique');
   writeln ('4. Projection parallle isomtrique');
   writeln;write ('Quel est le numro choisi : ');readln (Choix);
   writeln;
   DE := 1;
   Projection := Parallele;
   Case Choix of
     1:begin
         write ('Distance Rho= ');readln (Rho);
         write ('Angle Theta= ');readln (Theta);
         write ('Angle Phi= ');readln (Phi);
         Projection := Perspective
       end;
     2:begin
         write ('Angle Theta= ');readln (Theta);
         write ('Angle Phi= ');readln (Phi)
       end;
     3:begin
         Theta:=22.20765;
         Phi:=20.704811
       end;
     4:begin
         Theta:=45;
         Phi:=35.26439;
       end
   end
end;

procedure InitialisationsDiverses;
var Aux: real;
    I  : integer;
begin
   IncX := (X2 - X1) / NbrePoints;
   IncY := (Y2 - Y1) / NbreLignes;
   C1 := 0;      C2 := 718;      C3 := 1;       C4 := LimY;
   F1 := 1E37;   F2 := -1E37;    F3 := 1E37;    F4 := -1E37;
   Xg := -1;     Yg := -1;       Xd := -1;      Yd := -1;
   fillchar (HMax, SizeOf (HMax), 0);
   for I := 0 to LimX do HMin [I] := LimY;
   if (Theta < 0) or (Theta > 180)
   then begin
           Aux := X1;   X1 := X2;   X2 := Aux;   IncX := - IncX;
           Aux := Y1;   Y1 := Y2;   Y2 := Aux;   IncY := - IncY
        end
end;

procedure RechercheFenetre;
var X, Y, Z: real;
    Ligne, Point: integer;
begin
   for Ligne := 0 to NbreLignes do
   begin
      Y := Y2 - Ligne * IncY;
      for Point := 0 to NbrePoints do
      begin
         X := X1 + Point * IncX;
         Z := F(X, Y);
         Projette (X, Y, Z);
         if XProj < F1 then F1 := XProj;
         if XProj > F2 then F2 := XProj;
         if YProj < F3 then F3 := YProj;
         if YProj > F4 then F4 := YProj
      end
   end
end;

procedure CalculeEchelles;
begin
   EchX := (C2 - C1) / (F2 - F1);
   EchY := (C4 - C3) / (F4 - F3);
   if upcase(Vue) = 'R'
      then if EchX < EchY then EchY := EchX else EchX := EchY
end;

procedure Horizon (X1, Y1, X2, Y2: integer);
var X, Y, dX : integer;
    Pente    : real;

   function Max (X1, X2: integer): integer;
   begin
      if X1 > X2 then Max := X1 else Max := X2
   end;

   function Min (X1, X2: integer): integer;
   begin
      if X1 < X2 then Min := X1 else Min := X2
   end;

begin
   dX := Signe(X2 - X1);
   if dX = 0
   then
      begin
         HMax[X2 + 1] := Max (HMax[X2], Y2);
         HMin[X2 + 1] := Min (HMin[X2], Y2)
      end
   else
      begin
         Pente := (Y2 - Y1) / (X2 - X1);
         for X := X2 + 1 to X1 do
         begin
            Y := round(Pente * (X - X1) + Y1);
            HMax[X] := Max (HMax[X], Y);
            HMin[X] := Min (HMin[X], Y)
         end
      end
end;

procedure Visibilite (X, Y: integer; var Visi: shortint);
begin
   if (Y < HMax[X]) and (Y > HMin[X])
      then Visi := 0
      else if y >= HMax[X] then Visi := 1 else Visi := -1
end;

procedure Inter (X1,Y1,X2,Y2:longint;var TabAux:Table;var Xi,Yi:integer);
var Den, Xii, Yii: real;
begin
   if X2 - X1 = 0
   then begin
           Xii := X2;
           Yii := TabAux[X2]
        end
   else begin
           Den := Y2 - Y1 - TabAux[X2] + TabAux[X1];
           if Den <> 0
           then begin
                  Xii:=(X1*(Y2-TabAux[X2])+X2*(TabAux[X1]-Y1))/Den;
                  Yii := (Y2 * TabAux[X1] - Y1 * TabAux[X2]) / Den
                   end
              else begin
                      Xii := X2;
                      Yii := Y2
                   end
           end;
   Xi := round(Xii);
   Yi := round(Yii)
 end;

procedure AreteDeFermeture (X,Y:integer;var XLateral,YLateral:integer);
begin
   if XLateral <> -1 then Horizon (XLateral, YLateral, X, Y);
   XLateral := X;
   YLateral := Y
end;

procedure DessineFonction;
var Xe , Ye : integer;
    Ligne, Point : integer;
    XPrec, YPrec: integer;
    XCour, YCour: integer;
    Xi, Yi : integer;
    VisiCour, VisiPrec : shortint;
    X, Y, Z : real;
begin
  for Ligne := 0 to NbreLignes do
  begin
    Y := Y2 - Ligne * IncY;
    X := X1;
    Z := F(X, Y);
    Projette (X, Y, Z);
    XPrec :=round((XProj - F1) * EchX) + C1;
    YPrec :=round((YProj - F3) * EchY) + C3;
    AreteDeFermeture (XPrec, YPrec, Xd, Yd);
    MoveTo (XPrec, LimY - YPrec);
    Visibilite (XPrec, YPrec, VisiPrec);
    for Point := 0 to NbrePoints do
    begin
      X := X1 + Point *  IncX;
      Z := F(X, Y);
      Projette (X, Y, Z);
      XCour :=round((XProj - F1) * EchX) + C1;
      YCour :=round((YProj - F3) * EchY) + C3;
      Visibilite (XCour, YCour, VisiCour);
      if (HMax[XCour]=0) or (HMin[XCour]=LimY) then VisiCour:=VisiPrec;
      if VisiCour = VisiPrec
      then
        begin
          if (VisiCour = 1) or (VisiCour = -1) then
          begin
             Line (Xprec, LimY - YPrec,XCour, LimY - YCour);
             Horizon (XPrec, YPrec, XCour, YCour)
          end
        end
      else
        begin
          if VisiCour = 0
          then
            begin
              if VisiPrec = 1
                then Inter (XPrec,YPrec,XCour,YCour,Hmax,Xi,Yi)
                else Inter (XPrec,YPrec,XCour,YCour,HMin,Xi,Yi);
              Line (XPrec, LimY - YPrec,Xi, LimY - Yi);
              Horizon (XPrec, YPrec, Xi, Yi)
            end
          else
            begin
              if VisiCour = 1
              then
                begin
                  if VisiPrec = 0
                  then
                    begin
                       Inter (XPrec,YPrec,XCour,YCour,HMax,Xi,Yi);
                       Line (Xi, LimY - Yi, XCour, LimY - YCour);
                       Horizon (Xi, Yi, XCour, YCour)
                    end
                  else
                    begin
                      Inter (XPrec,YPrec,XCour,YCour,HMin,Xi,Yi);
                      Line (XPrec, LimY - YPrec,Xi, LimY - Yi);
                      Horizon (XPrec, YPrec, Xi, Yi);
                      Inter (XPrec,YPrec,XCour,YCour,HMax,Xi,Yi);
                      Line (Xi, LimY - Yi,XCour,LimY - YCour);
                      Horizon (Xi, Yi, XCour, YCour)
                    end
                end
              else
                begin
                  if VisiPrec = 0
                  then
                    begin
                      Inter (XPrec,YPrec,XCour,YCour,HMin,Xi,Yi);
                      Line (Xi, LimY - Yi,XCour,LimY - YCour);
                      Horizon (Xi, Yi, XCour, YCour)
                    end
                  else
                    begin
                      Inter (XPrec,YPrec,XCour,YCour,HMax,Xi,Yi);
                      Line (XPrec, LimY - YPrec,Xi, LimY - Yi);
                      Horizon (XPrec, YPrec, Xi, Yi);
                      Inter (XPrec,YPrec,XCour,YCour,HMin,Xi,Yi);
                      Line (Xi,LimY - Yi,XCour,LimY - YCour);
                      Horizon (Xi, Yi, XCour, YCour)
                    end
                end
            end
        end;
      VisiPrec := VisiCour;
      XPrec := XCour;
      YPrec := YCour
    end;
  AreteDeFermeture (XCour, YCour, Xg, Yg)
  end
end;

procedure Affichage;
var Aux, Ch: string;
begin
   str(X1:4:1, Aux);   Ch := concat('X=[', Aux, ',');
   str(X2:4:1, Aux);   Ch := concat(Ch, Aux, ']   ');
   str(Y1:4:1, Aux);   Ch := concat(Ch, 'Y=[', Aux, ',');
   str(Y2:4:1, Aux);   Ch := concat(Ch, Aux, ']   ');
   if Projection = Perspective then
     begin
        str(Rho:4:1, Aux);  Ch:=concat(Ch, 'Rho=', Aux, '   ')
     end;
   str(Theta:5:3, Aux);     Ch:=concat(Ch, 'Theta=', Aux, '   ');
   str(Phi:5:3, Aux);       Ch:=concat(Ch, 'Phi=', Aux, '   ');
   str(NbreLignes:2, Aux);  Ch:=concat(Ch, 'Lig=', Aux, '   ');
   str(NbrePoints:3, Aux);  Ch:=concat(Ch, 'Pts=', Aux);
   OutTextXY(1,340, Ch)
end;

BEGIN
   EntreeDesParametresDeVision;
   InitialisationsDiverses;
   InitialiseProjection;
   RechercheFenetre;
   CalculeEchelles;
   EcranGraphique3D;
   DessineFonction;
   Affichage;
   Attente3D;
   EcranTexte3D
END.
